var _excluded = ["operator", "value", "handleOnChange", "title", "className", "type", "inputType", "values", "listsAsArrays", "parseNumbers", "fieldData", "disabled", "separator", "skipHook", "testID", "selectorComponent"], _excluded2 = ["controlClassnames", "controlElements", "debugMode", "enableDragAndDrop", "enableMountQueryChange", "translations"];
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null)
    return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0)
      continue;
    target[key] = source[key];
  }
  return target;
}
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
import { hooks, isVue2, defineComponent, setup as _setup, appProperties, $prefix } from "@dftvue2-opentiny/vue-common";
import { renderless, api } from "@dftvue2-opentiny/vue-renderless/query-builder/vue";
import Button from "@dftvue2-opentiny/vue-button";
function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function hook2(context) {
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

import Select from "@dftvue2-opentiny/vue-select";
import Option from "@dftvue2-opentiny/vue-option";
import OptionGroup from "@dftvue2-opentiny/vue-option-group";
import Checkbox from "@dftvue2-opentiny/vue-checkbox";
import { IconNodeOpen, IconEditorEraser, IconPlus, IconDel, IconNode } from "@dftvue2-opentiny/vue-icon";
import Input$1 from "@dftvue2-opentiny/vue-input";
import Numeric from "@dftvue2-opentiny/vue-numeric";
import DatePicker from "@dftvue2-opentiny/vue-date-picker";
import TimePicker from "@dftvue2-opentiny/vue-time-picker";
import Radio from "@dftvue2-opentiny/vue-radio";
import { random } from "@dftvue2-opentiny/vue-renderless/common/string";
import "@dftvue2-opentiny/vue-theme/query-builder/index.css";
var classLoophandler = function classLoophandler2(data3) {
  if (Array.isArray(data3)) {
    return data3.filter(Boolean).map(function(item) {
      return classLoophandler2(item);
    }).filter(Boolean).join(" ");
  } else if (typeof data3 === "object") {
    var arr = Object.keys(data3).map(function(key) {
      return data3[key] && key;
    });
    return classLoophandler2(arr);
  } else {
    return data3;
  }
};
var clsx = function clsx2() {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }
  var className = classLoophandler(args);
  return className;
};
var useContext = function useContext2(inject) {
  return inject;
};
var useMemo = function useMemo2(fn) {
  var _hooks$computed;
  return (_hooks$computed = hooks.computed(fn)) == null ? void 0 : _hooks$computed.value;
};
var useCallback = function useCallback2(fn) {
  return fn;
};
var useRef = function useRef2(refName, context) {
  var vm = context || this;
  return {
    current: vm == null ? void 0 : vm.$refs[refName]
  };
};
var HookLayout = (
  /*    */
  2
);
var HookPassive = (
  /*   */
  4
);
var currentlyRenderingFiber = null;
var workInProgressHook = null;
var currentHook = null;
function scheduleUpdateOnFiber(wip) {
  currentlyRenderingFiber.alternate = _extends({}, currentlyRenderingFiber);
  renderHooks(wip);
  currentlyRenderingFiber.update();
}
function renderHooks(wip) {
  currentlyRenderingFiber = wip;
  currentlyRenderingFiber.memorizedState = null;
  workInProgressHook = null;
}
function updateWorkInProgressHook() {
  var instance = hooks.getCurrentInstance();
  if (isVue2) {
    instance = instance.proxy;
  }
  if (!currentlyRenderingFiber || currentlyRenderingFiber.uid !== instance.uid) {
    renderHooks(instance);
  }
  var current = currentlyRenderingFiber.alternate;
  var hook;
  if (current) {
    currentlyRenderingFiber.memorizedState = current.memorizedState;
    if (workInProgressHook) {
      hook = workInProgressHook = workInProgressHook.next;
      currentHook = currentHook.next;
    } else {
      hook = workInProgressHook = current.memorizedState;
      currentHook = current.memorizedState;
    }
  } else {
    currentHook = null;
    hook = {
      memorizedState: null,
      next: null
    };
    if (workInProgressHook) {
      workInProgressHook = workInProgressHook.next = hook;
    } else {
      workInProgressHook = currentlyRenderingFiber.memorizedState = hook;
    }
  }
  return hook;
}
function useState(initalState) {
  return useReducer(null, initalState);
}
function useReducer(reducer, initalState) {
  var hook = updateWorkInProgressHook();
  if (!currentlyRenderingFiber.alternate) {
    hook.memorizedState = initalState;
  }
  var dispatch = dispatchReducerAction.bind(null, currentlyRenderingFiber, hook, reducer);
  return [hook.memorizedState, dispatch];
}
function dispatchReducerAction(fiber, hook, reducer, action) {
  hook.memorizedState = reducer ? reducer(hook.memorizedState, action) : action;
  scheduleUpdateOnFiber(fiber);
}
function updateEffectImp(hookFlags, create, deps) {
  var hook = updateWorkInProgressHook();
  if (currentHook) {
    var prevEffect = currentHook.memorizedState;
    if (deps) {
      var prevDeps = prevEffect.deps;
      if (areHookInputsEqual(deps, prevDeps)) {
        return;
      }
    }
  }
  var effect = {
    hookFlags,
    create,
    deps
  };
  hook.memorizedState = effect;
  invokeHooks(hookFlags, hook);
}
function useEffect(create, deps) {
  return updateEffectImp(HookPassive, create, deps);
}
function areHookInputsEqual(nextDeps, prevDeps) {
  if (prevDeps === null) {
    return false;
  }
  for (var i = 0; i < prevDeps.length && i < nextDeps.length; i++) {
    if (Object.is(nextDeps[i], prevDeps[i])) {
      continue;
    }
    return false;
  }
  return true;
}
function invokeHooks(hookFlags, hook) {
  if (hookFlags & HookPassive) {
    postMessage(hook.memorizedState.create);
  } else if (hookFlags & HookLayout) {
    hooks.watchEffect(hook.memorizedState.create, {
      flush: "post"
    });
  }
}
var postMessage = function postMessage2(create) {
  var _MessageChannel = new MessageChannel(), port1 = _MessageChannel.port1, port2 = _MessageChannel.port2;
  port1.onmessage = function() {
    create();
  };
  port2.postMessage(null);
};
var placeholderName = "~";
var placeholderLabel = "------";
var defaultPlaceholderFieldName = placeholderName;
var defaultPlaceholderFieldLabel = placeholderLabel;
var defaultPlaceholderFieldGroupLabel = placeholderLabel;
var defaultPlaceholderOperatorName = placeholderName;
var defaultPlaceholderOperatorLabel = placeholderLabel;
var defaultPlaceholderOperatorGroupLabel = placeholderLabel;
var defaultJoinChar = ",";
var defaultTranslations = {
  fields: {
    title: "字段",
    placeholderName: defaultPlaceholderFieldName,
    placeholderLabel: defaultPlaceholderFieldLabel,
    placeholderGroupLabel: defaultPlaceholderFieldGroupLabel
  },
  operators: {
    title: "操作符",
    placeholderName: defaultPlaceholderOperatorName,
    placeholderLabel: defaultPlaceholderOperatorLabel,
    placeholderGroupLabel: defaultPlaceholderOperatorGroupLabel
  },
  value: {
    title: "值"
  },
  removeRule: {
    label: "x",
    title: "移除规则"
  },
  clearData: {
    label: "",
    title: "清除数据"
  },
  removeGroup: {
    label: "x",
    title: "移除条件组"
  },
  addRule: {
    label: "添加规则",
    title: "添加规则"
  },
  addGroup: {
    label: "新增子条件组",
    title: "新增子条件组"
  },
  combinators: {
    title: "Combinators"
  },
  notToggle: {
    label: "Not",
    title: "反转条件组"
  },
  cloneRule: {
    label: "⧉",
    title: "复制规则"
  },
  cloneRuleGroup: {
    label: "⧉",
    title: "复制条件组"
  },
  dragHandle: {
    label: "⁞⁞",
    title: "拖拽"
  },
  lockRule: {
    label: "🔓",
    title: "锁定规则"
  },
  lockGroup: {
    label: "🔓",
    title: "锁定条件组"
  },
  lockRuleDisabled: {
    label: "🔒",
    title: "解锁规则"
  },
  lockGroupDisabled: {
    label: "🔒",
    title: "解锁条件组"
  },
  valueSourceSelector: {
    title: "数据来源"
  }
};
var defaultOperators = [{
  name: "=",
  label: "="
}, {
  name: "!=",
  label: "!="
}, {
  name: "<=",
  label: "<="
}, {
  name: ">=",
  label: ">="
}, {
  name: "<",
  label: "<"
}, {
  name: ">",
  label: ">"
}, {
  name: "doesNotContain",
  label: "does not contain"
}, {
  name: "doesNotBeginWith",
  label: "does not begin with"
}, {
  name: "doesNotEndWith",
  label: "does not end with"
}, {
  name: "contains",
  label: "contains"
}, {
  name: "beginsWith",
  label: "begins with"
}, {
  name: "endsWith",
  label: "ends with"
}, {
  name: "in",
  label: "in"
}, {
  name: "notIn",
  label: "not in"
}, {
  name: "null",
  label: "is null"
}, {
  name: "notNull",
  label: "is not null"
}, {
  name: "between",
  label: "between"
}, {
  name: "notBetween",
  label: "not between"
}];
var defaultCombinators = [{
  name: "and",
  label: "且"
}, {
  name: "or",
  label: "或"
}];
[].concat(defaultCombinators, [{
  name: "xor",
  label: "XOR"
}]);
var groupButtonClass = " group-button";
var standardClassnames = {
  ruleGroup: "ruleGroup",
  queryBuilder: "queryBuilder",
  header: "ruleGroup-header",
  combinators: "ruleGroup-combinators",
  body: "ruleGroup-body",
  addRule: "ruleGroup-addRule" + groupButtonClass,
  addGroup: "ruleGroup-addGroup" + groupButtonClass,
  cloneRule: "rule-cloneRule" + groupButtonClass,
  cloneGroup: "ruleGroup-cloneGroup" + groupButtonClass,
  removeGroup: "ruleGroup-remove" + groupButtonClass,
  notToggle: "ruleGroup-notToggle",
  rule: "query-builder-rule",
  fields: "rule-fields",
  operators: "rule-operators",
  value: "rule-value",
  removeRule: "rule-remove" + groupButtonClass,
  clearData: "clear-data" + groupButtonClass,
  betweenRules: "betweenRules",
  valid: "queryBuilder-valid",
  invalid: "queryBuilder-invalid",
  dndDragging: "dndDragging",
  dndOver: "dndOver",
  dndCopy: "dndCopy",
  dragHandle: "queryBuilder-dragHandle",
  disabled: "queryBuilder-disabled",
  lockRule: "rule-lock",
  lockGroup: "ruleGroup-lock",
  valueSource: "rule-valueSource",
  valueListItem: "rule-value-list-item",
  branches: "queryBuilder-branches",
  displayOnlyField: "display-only-field"
};
var defaultControlClassnames = {
  ruleGroup: "",
  queryBuilder: "",
  header: "",
  addRule: "",
  body: "",
  combinators: "",
  cloneGroup: "",
  addGroup: "",
  removeGroup: "",
  cloneRule: "",
  rule: "",
  notToggle: "",
  operators: "",
  fields: "",
  value: "",
  clearData: "",
  lockRule: "",
  dragHandle: "",
  lockGroup: "",
  valueSource: "",
  removeRule: ""
};
var groupInvalidReasons = {
  empty: "empty",
  invalidCombinator: "invalid combinator",
  invalidIndependentCombinators: "invalid independent combinators"
};
var TestID = {
  rule: "rule",
  inlineCombinator: "inline-combinator",
  ruleGroup: "rule-group",
  addGroup: "add-group",
  cloneGroup: "clone-group",
  removeGroup: "remove-group",
  cloneRule: "clone-rule",
  addRule: "add-rule",
  combinators: "combinators",
  clearData: "clear-data",
  fields: "fields",
  removeRule: "remove-rule",
  operators: "operators",
  notToggle: "not-toggle",
  valueEditor: "value-editor",
  lockRule: "lock-rule",
  dragHandle: "drag-handle",
  valueSourceSelector: "value-source-selector",
  lockGroup: "lock-group"
};
var LogType = {
  parentPathDisabled: "action aborted: parent path disabled",
  pathDisabled: "action aborted: path is disabled",
  queryUpdate: "query updated",
  onAddRuleFalse: "onAddRule callback returned false",
  onAddGroupFalse: "onAddGroup callback returned false",
  onRemoveFalse: "onRemove callback returned false",
  add: "rule or group added",
  remove: "rule or group removed",
  update: "rule or group updated",
  move: "rule or group moved"
};
var splitBy = function splitBy2(str, splitChar) {
  if (splitChar === void 0) {
    splitChar = defaultJoinChar;
  }
  return typeof str === "string" ? str.split("\\" + splitChar).map(function(c) {
    return c.split(splitChar);
  }).reduce(function(prev, curr, idx) {
    if (idx === 0) {
      return curr;
    }
    return [].concat(prev.slice(0, prev.length - 1), ["" + prev[prev.length - 1] + splitChar + curr[0]], curr.slice(1));
  }, []) : [];
};
var joinWith = function joinWith2(strArr, joinChar) {
  if (joinChar === void 0) {
    joinChar = defaultJoinChar;
  }
  return strArr.map(function(str) {
    return ("" + (str != null ? str : "")).replaceAll(joinChar, "\\" + joinChar);
  }).join(joinChar);
};
var trimIfString = function trimIfString2(val) {
  return typeof val === "string" ? val.trim() : val;
};
var toArray = function toArray2(v) {
  return Array.isArray(v) ? v.map(trimIfString) : typeof v === "string" ? splitBy(v, defaultJoinChar).filter(function(s) {
    return !/^\s*$/.test(s);
  }).map(function(s) {
    return s.trim();
  }) : typeof v === "number" ? [v] : [];
};
var processRuleOrStringOrRuleGroupIC = function processRuleOrStringOrRuleGroupIC2(r3) {
  return typeof r3 === "object" && "rules" in r3 ? generateRuleGroupICWithConsistentCombinators(r3) : r3;
};
var generateRuleGroupICWithConsistentCombinators = function generateRuleGroupICWithConsistentCombinators2(rg3) {
  var returnArr = [];
  var push = function push2(r3) {
    return returnArr.push(processRuleOrStringOrRuleGroupIC(r3));
  };
  var startIndex = 0;
  for (var i = 0; i < rg3.rules.length; i += 2) {
    if (rg3.rules.length === 1) {
      push(rg3.rules[0]);
    } else if (rg3.rules[i + 1] === "and") {
      startIndex = i;
      var j = 1;
      while (rg3.rules[startIndex + j] === "and") {
        i += 2;
        j += 2;
      }
      returnArr.push({
        // eslint-disable-next-line @typescript-eslint/ban-ts-comment
        // @ts-expect-error TS can't keep track of odd/even indexes here
        rules: rg3.rules.slice(startIndex, i + 1).map(processRuleOrStringOrRuleGroupIC)
      });
      i -= 2;
    } else if (rg3.rules[i + 1] === "or") {
      if (i === rg3.rules.length - 3 || i === 0) {
        if (rg3.rules[i - 1] === "or" || i === 0) {
          push(rg3.rules[i]);
        }
        push(rg3.rules[i + 1]);
        if (i === rg3.rules.length - 3) {
          push(rg3.rules[i + 2]);
        }
      } else {
        if (rg3.rules[i - 1] === "and") {
          push(rg3.rules[i + 1]);
        } else {
          push(rg3.rules[i]);
          push(rg3.rules[i + 1]);
        }
      }
    }
  }
  if (
    // eslint-disable-next-line @typescript-eslint/ban-ts-comment
    // @ts-expect-error TS still thinks returnArr has length 0
    returnArr.length === 1 && typeof returnArr[0] === "object" && "rules" in returnArr[0]
  ) {
    return _extends({}, rg3, returnArr[0]);
  }
  return _extends({}, rg3, {
    rules: returnArr
  });
};
var convertFromIC = function convertFromIC2(rg3) {
  var processedRG = generateRuleGroupICWithConsistentCombinators(rg3);
  var rulesAsMixedList = processedRG.rules.map(function(r3) {
    return typeof r3 === "string" || !("rules" in r3) ? r3 : convertFromIC2(r3);
  });
  var combinator = rulesAsMixedList.length < 2 ? "and" : rulesAsMixedList[1];
  var rules = rulesAsMixedList.filter(function(r3) {
    return typeof r3 !== "string";
  });
  return _extends({}, processedRG, {
    combinator,
    rules
  });
};
var defaultValidator = function defaultValidator2(query, validateRule) {
  var result = {};
  var validateGroup = function validateGroup2(rg3) {
    var reasons = [];
    if (rg3.rules.length === 0) {
      reasons.push(groupInvalidReasons.empty);
    } else if (!("combinator" in rg3)) {
      var invalidICs = false;
      for (var i = 0; !invalidICs && i < rg3.rules.length; i++) {
        if (typeof rg3.rules[i] === "string" && i % 2 === 0 || typeof rg3.rules[i] !== "string" && i % 2 === 1 || typeof rg3.rules[i] === "string" && i % 2 === 1 && !defaultCombinators.map(function(c) {
          return c.name;
        }).includes(rg3.rules[i])) {
          invalidICs = true;
        }
      }
      if (invalidICs) {
        reasons.push(groupInvalidReasons.invalidIndependentCombinators);
      }
    }
    if ("combinator" in rg3 && !defaultCombinators.map(function(c) {
      return c.name;
    }).includes(rg3.combinator) && rg3.rules.length > 1) {
      reasons.push(groupInvalidReasons.invalidCombinator);
    }
    if (rg3.id) {
      if (reasons.length) {
        result[rg3.id] = {
          valid: false,
          reasons
        };
      } else {
        result[rg3.id] = true;
      }
    }
    rg3.rules.forEach(function(r3) {
      if (typeof r3 === "string")
        ;
      else if ("rules" in r3) {
        validateGroup2(r3);
      } else if (typeof validateRule === "function") {
        result[r3.id] = validateRule(r3)[0];
      }
    });
  };
  validateGroup(query);
  return result;
};
var numericRegex = /^\s*[+-]?(\d+|\d*\.\d+|\d+\.\d*)([Ee][+-]?\d+)?\s*$/;
var isPojo = function isPojo2(obj) {
  return obj === null || typeof obj !== "object" ? false : Object.getPrototypeOf(obj) === Object.prototype;
};
var numerifyValues = function numerifyValues2(rg3) {
  return _extends({}, rg3, {
    // eslint-disable-next-line @typescript-eslint/ban-ts-comment
    // @ts-expect-error TS can't keep track of odd/even indexes here
    rules: rg3.rules.map(function(r3) {
      if (typeof r3 === "string") {
        return r3;
      } else if ("rules" in r3) {
        return numerifyValues2(r3);
      }
      var value2 = r3.value;
      if (typeof value2 === "string" && numericRegex.test(value2)) {
        value2 = parseFloat(value2);
      }
      return _extends({}, r3, {
        value: value2
      });
    })
  });
};
var isValidValue = function isValidValue2(v) {
  return typeof v === "string" && v.length > 0 || typeof v === "number" && !isNaN(v) || typeof v !== "string" && typeof v !== "number";
};
var shouldRenderAsNumber = function shouldRenderAsNumber2(v, parseNumbers) {
  return !!parseNumbers && (typeof v === "number" || typeof v === "bigint" || typeof v === "string" && numericRegex.test(v));
};
var isValueProcessorLegacy = function isValueProcessorLegacy2(vp) {
  return vp.length >= 3;
};
var defaultValueProcessorByRule = function defaultValueProcessorByRule2(_ref, _temp) {
  var operator = _ref.operator, value2 = _ref.value, valueSource = _ref.valueSource;
  var _ref2 = _temp === void 0 ? {} : _temp, escapeQuotes = _ref2.escapeQuotes, parseNumbers = _ref2.parseNumbers;
  var escapeSingleQuotes = function escapeSingleQuotes2(v) {
    return typeof v !== "string" || !escapeQuotes ? v : v.replaceAll("'", "''");
  };
  var valueIsField = valueSource === "field";
  var operatorLowerCase = operator.toLowerCase();
  if (operatorLowerCase === "null" || operatorLowerCase === "notnull") {
    return "";
  } else if (operatorLowerCase === "in" || operatorLowerCase === "notin") {
    var valueAsArray = toArray(value2);
    if (valueAsArray.length > 0) {
      return "(" + valueAsArray.map(function(v) {
        return valueIsField || shouldRenderAsNumber(v, parseNumbers) ? "" + trimIfString(v) : "'" + escapeSingleQuotes(v) + "'";
      }).join(", ") + ")";
    }
    return "";
  } else if (operatorLowerCase === "between" || operatorLowerCase === "notbetween") {
    var _valueAsArray = toArray(value2);
    if (_valueAsArray.length >= 2 && isValidValue(_valueAsArray[0]) && isValidValue(_valueAsArray[1])) {
      var first = _valueAsArray[0], second = _valueAsArray[1];
      return valueIsField || shouldRenderAsNumber(first, parseNumbers) && shouldRenderAsNumber(second, parseNumbers) ? trimIfString(first) + " and " + trimIfString(second) : "'" + escapeSingleQuotes(first) + "' and '" + escapeSingleQuotes(second) + "'";
    }
    return "";
  } else if (operatorLowerCase === "contains" || operatorLowerCase === "doesnotcontain") {
    return valueIsField ? "'%' || " + value2 + " || '%'" : "'%" + escapeSingleQuotes(value2) + "%'";
  } else if (operatorLowerCase === "beginswith" || operatorLowerCase === "doesnotbeginwith") {
    return valueIsField ? value2 + " || '%'" : "'" + escapeSingleQuotes(value2) + "%'";
  } else if (operatorLowerCase === "endswith" || operatorLowerCase === "doesnotendwith") {
    return valueIsField ? "'%' || " + value2 : "'%" + escapeSingleQuotes(value2) + "'";
  } else if (typeof value2 === "boolean") {
    return ("" + value2).toUpperCase();
  }
  return valueIsField || shouldRenderAsNumber(value2, parseNumbers) ? "" + trimIfString(value2) : "'" + escapeSingleQuotes(value2) + "'";
};
var convertOperator = function convertOperator2(op) {
  return op.replace(/^(=)$/, "$1=").replace(/^notNull$/i, "!=").replace(/^null$/i, "==");
};
var negateIfNotOp = function negateIfNotOp2(op, jsonRule) {
  return /^(does)?not/i.test(op) ? {
    "!": jsonRule
  } : jsonRule;
};
var defaultRuleProcessorJsonLogic = function defaultRuleProcessorJsonLogic2(_ref3, _temp2) {
  var field = _ref3.field, operator = _ref3.operator, value2 = _ref3.value, valueSource = _ref3.valueSource;
  var _ref4 = _temp2 === void 0 ? {} : _temp2, parseNumbers = _ref4.parseNumbers;
  var valueIsField = valueSource === "field";
  var fieldObject = {
    var: field
  };
  var fieldOrNumberRenderer = function fieldOrNumberRenderer2(v) {
    return valueIsField ? {
      var: "" + v
    } : shouldRenderAsNumber(v, parseNumbers) ? parseFloat(v) : v;
  };
  if (operator === "<" || operator === "<=" || operator === "=" || operator === "!=" || operator === ">" || operator === ">=") {
    var _ref5;
    return _ref5 = {}, _ref5[convertOperator(operator)] = [fieldObject, fieldOrNumberRenderer(value2)], _ref5;
  } else if (operator === "null" || operator === "notNull") {
    var _ref6;
    return _ref6 = {}, _ref6[(operator === "notNull" ? "!" : "=") + "="] = [fieldObject, null], _ref6;
  } else if (operator === "in" || operator === "notIn") {
    var valueAsArray = toArray(value2).map(fieldOrNumberRenderer);
    if (valueAsArray.length > 0) {
      var jsonRule = {
        in: [fieldObject, valueAsArray]
      };
      return negateIfNotOp(operator, jsonRule);
    }
    return false;
  } else if (operator === "between" || operator === "notBetween") {
    var _valueAsArray2 = toArray(value2);
    if (_valueAsArray2.length >= 2 && isValidValue(_valueAsArray2[0]) && isValidValue(_valueAsArray2[1])) {
      var first = _valueAsArray2[0], second = _valueAsArray2[1];
      if (!valueIsField && shouldRenderAsNumber(first, true) && shouldRenderAsNumber(second, true)) {
        var firstNum = parseFloat(first);
        var secondNum = parseFloat(second);
        if (secondNum < firstNum) {
          var tempNum = secondNum;
          second = firstNum;
          first = tempNum;
        } else {
          first = firstNum;
          second = secondNum;
        }
      } else if (valueIsField) {
        first = {
          var: first
        };
        second = {
          var: second
        };
      }
      var _jsonRule = {
        "<=": [first, fieldObject, second]
      };
      return negateIfNotOp(operator, _jsonRule);
    }
    return false;
  } else if (operator === "contains" || operator === "doesNotContain") {
    var _jsonRule2 = {
      in: [fieldOrNumberRenderer(value2), fieldObject]
    };
    return negateIfNotOp(operator, _jsonRule2);
  } else if (operator === "beginsWith" || operator === "doesNotBeginWith") {
    var _jsonRule3 = {
      startsWith: [fieldObject, fieldOrNumberRenderer(value2)]
    };
    return negateIfNotOp(operator, _jsonRule3);
  } else if (operator === "endsWith" || operator === "doesNotEndWith") {
    var _jsonRule4 = {
      endsWith: [fieldObject, fieldOrNumberRenderer(value2)]
    };
    return negateIfNotOp(operator, _jsonRule4);
  }
  return false;
};
var isValidationResult = function isValidationResult2(vrs) {
  return isPojo(vrs) && typeof vrs.valid === "boolean";
};
var isRuleOrGroupValid = function isRuleOrGroupValid2(rg3, validationResults, validator) {
  if (typeof validationResults === "boolean") {
    return validationResults;
  }
  if (isValidationResult(validationResults)) {
    return validationResults.valid;
  }
  if (!("rules" in rg3) && typeof validator === "function") {
    var vrs = validator(rg3);
    if (typeof vrs === "boolean") {
      return vrs;
    }
    if (isValidationResult(vrs)) {
      return vrs.valid;
    }
  }
  return true;
};
var uniqByName = function uniqByName2(originalArray) {
  var newArray = [];
  var name = /* @__PURE__ */ new Set();
  originalArray.forEach(function(el) {
    if (!name.has(el.name)) {
      name.add(el.name);
      newArray.push(el);
    }
  });
  return newArray;
};
var uniqOptGroups = function uniqOptGroups2(originalArray) {
  var label = /* @__PURE__ */ new Set();
  var name = /* @__PURE__ */ new Set();
  var newArray = [];
  originalArray.forEach(function(el) {
    if (!label.has(el.label)) {
      label.add(el.label);
      var optionsForThisGroup = [];
      el.options.forEach(function(opt) {
        if (!name.has(opt.name)) {
          name.add(opt.name);
          optionsForThisGroup.push(opt);
        }
      });
      newArray.push(_extends({}, el, {
        options: optionsForThisGroup
      }));
    }
  });
  return newArray;
};
function formatQuery(ruleGroup2, options) {
  if (options === void 0) {
    options = {};
  }
  var format = "json";
  var valueProcessorInternal = defaultValueProcessorByRule;
  var ruleProcessorInternal = null;
  var validator = function validator2() {
    return true;
  };
  var fields = [];
  var validationMap = {};
  var fallbackExpression = "";
  var parseNumbers = false;
  var placeholderFieldName = defaultPlaceholderFieldName;
  var placeholderOperatorName = defaultPlaceholderOperatorName;
  if (typeof options === "string") {
    format = options.toLowerCase();
    if (format === "jsonlogic") {
      ruleProcessorInternal = defaultRuleProcessorJsonLogic;
    }
  } else {
    var _options$format, _ruleProcessorInterna, _options$validator, _options$fields, _options$fallbackExpr, _options$paramPrefix, _options$placeholderF, _options$placeholderO;
    format = ((_options$format = options.format) != null ? _options$format : "json").toLowerCase();
    var _options = options, _options$valueProcess = _options.valueProcessor, valueProcessor = _options$valueProcess === void 0 ? null : _options$valueProcess, _options$ruleProcesso = _options.ruleProcessor, ruleProcessor = _options$ruleProcesso === void 0 ? null : _options$ruleProcesso;
    if (typeof ruleProcessor === "function") {
      ruleProcessorInternal = ruleProcessor;
    }
    valueProcessorInternal = typeof valueProcessor === "function" ? function(r3, opts) {
      return isValueProcessorLegacy(valueProcessor) ? valueProcessor(r3.field, r3.operator, r3.value, r3.valueSource) : valueProcessor(r3, opts);
    } : format === "jsonlogic" ? (_ruleProcessorInterna = ruleProcessorInternal) != null ? _ruleProcessorInterna : defaultRuleProcessorJsonLogic : defaultValueProcessorByRule;
    if (Array.isArray(options.quoteFieldNamesWith)) {
      options.quoteFieldNamesWith;
    } else if (typeof options.quoteFieldNamesWith === "string") {
      [options.quoteFieldNamesWith, options.quoteFieldNamesWith];
    }
    validator = (_options$validator = options.validator) != null ? _options$validator : function() {
      return true;
    };
    fields = (_options$fields = options.fields) != null ? _options$fields : [];
    fallbackExpression = (_options$fallbackExpr = options.fallbackExpression) != null ? _options$fallbackExpr : "";
    (_options$paramPrefix = options.paramPrefix) != null ? _options$paramPrefix : ":";
    parseNumbers = !!options.parseNumbers;
    placeholderFieldName = (_options$placeholderF = options.placeholderFieldName) != null ? _options$placeholderF : defaultPlaceholderFieldName;
    placeholderOperatorName = (_options$placeholderO = options.placeholderOperatorName) != null ? _options$placeholderO : defaultPlaceholderOperatorName;
  }
  if (!fallbackExpression) {
    fallbackExpression = "(1 = 1)";
  }
  if (format === "json" || format === "json_without_ids") {
    var rg3 = parseNumbers ? numerifyValues(ruleGroup2) : ruleGroup2;
    if (format === "json") {
      return JSON.stringify(rg3, null, 2);
    } else {
      return JSON.stringify(rg3, ["rules", "field", "value", "operator", "combinator", "not", "valueSource"]);
    }
  } else {
    if (typeof validator === "function") {
      var validationResults = validator(ruleGroup2);
      if (typeof validationResults === "boolean") {
        if (validationResults === false) {
          return format === "jsonlogic" ? false : fallbackExpression;
        }
      } else {
        validationMap = validationResults;
      }
    }
    var validatorMap = {};
    var uniqueFields = uniqByName(fields);
    uniqueFields.forEach(function(fd) {
      if (typeof fd.validator === "function") {
        validatorMap[fd.name] = fd.validator;
      }
    });
    var validateRule = function validateRule2(rule) {
      var validationResults2 = void 0;
      var fieldValidator = void 0;
      if (rule.id) {
        validationResults2 = validationMap[rule.id];
      }
      if (fields.length) {
        var fieldArrs = fields.filter(function(f) {
          return f.name === rule.field;
        });
        if (fieldArrs.length) {
          var field = fieldArrs[0];
          if (typeof field.validator === "function") {
            fieldValidator = field.validator;
          }
        }
      }
      return [validationResults2, fieldValidator];
    };
    if (format === "jsonlogic") {
      var query = "combinator" in ruleGroup2 ? ruleGroup2 : convertFromIC(ruleGroup2);
      var processRuleGroup = function processRuleGroup2(rg4) {
        var _rg$id, _ref7;
        if (!isRuleOrGroupValid(rg4, validationMap[(_rg$id = rg4.id) != null ? _rg$id : (
          /* istanbul ignore next */
          ""
        )])) {
          return false;
        }
        var processedRules = rg4.rules.map(function(rule) {
          var _ruleProcessorInterna2;
          if ("rules" in rule) {
            return processRuleGroup2(rule);
          }
          var _validateRule = validateRule(rule), validationResult = _validateRule[0], fieldValidator = _validateRule[1];
          if (!isRuleOrGroupValid(rule, validationResult, fieldValidator) || rule.field === placeholderFieldName || rule.operator === placeholderOperatorName) {
            return false;
          }
          return ((_ruleProcessorInterna2 = ruleProcessorInternal) != null ? _ruleProcessorInterna2 : valueProcessorInternal)(rule, {
            parseNumbers
          });
        }).filter(Boolean);
        if (processedRules.length === 0) {
          return false;
        }
        var jsonRuleGroup = processedRules.length === 1 ? processedRules[0] : (_ref7 = {}, _ref7[rg4.combinator] = processedRules, _ref7);
        return rg4.not ? {
          "!": jsonRuleGroup
        } : jsonRuleGroup;
      };
      return processRuleGroup(query);
    } else {
      return "";
    }
  }
}
var getValidationClassNames = function getValidationClassNames2(validationResult) {
  var valid = typeof validationResult === "boolean" ? validationResult : typeof validationResult === "object" && validationResult !== null ? validationResult.valid : null;
  return typeof valid === "boolean" ? valid ? standardClassnames.valid : standardClassnames.invalid : "";
};
var getValueSourcesUtil = function getValueSourcesUtil2(fieldData, operator, getValueSources) {
  var fd = fieldData != null ? fieldData : (
    /* istanbul ignore else */
    {}
  );
  if (fd.valueSources) {
    if (typeof fd.valueSources === "function") {
      return fd.valueSources(operator);
    }
    return fd.valueSources;
  }
  if (getValueSources) {
    var vals = getValueSources(fd.name, operator);
    if (vals)
      return vals;
  }
  return ["value"];
};
var cryptoModule = globalThis.crypto;
var generateID = function generateID2() {
  return "00-0-4-2-000".replace(/[^-]/g, function(s) {
    return ((random() + ~~s) * 65536 >> s).toString(16).padStart(4, "0");
  });
};
if (cryptoModule) {
  if (typeof cryptoModule.randomUUID === "function") {
    generateID = function generateID3() {
      return cryptoModule.randomUUID();
    };
  } else if (typeof cryptoModule.getRandomValues === "function") {
    var template = [
      "".padEnd(8, "x"),
      "".padEnd(4, "x"),
      // third section starts with the UUID version
      "4".padEnd(4, "x"),
      // First character of fourth section is limited to four specific characters
      "y".padEnd(4, "x"),
      "".padEnd(12, "x")
    ].join("-");
    var position19vals = ["8", "9", "a", "b"];
    var re = /[xy]/g;
    var container = new Uint32Array(32);
    generateID = function generateID3() {
      cryptoModule.getRandomValues(container);
      var i = -1;
      return template.replaceAll(re, function(char) {
        i++;
        return char === "y" ? position19vals[container[i] % 4] : (container[i] % 16).toString(16);
      });
    };
  }
}
var usePrevious = function usePrevious2(value2, context) {
  var ref = useRef(null, context);
  useEffect(function() {
    ref.current = value2;
  }, [value2]);
  return ref.current;
};
var useControlledOrUncontrolled = function useControlledOrUncontrolled2(_ref8) {
  var defaultQuery = _ref8.defaultQuery, queryProp = _ref8.queryProp, isFirstRender = _ref8.isFirstRender;
  var prevQueryPresent = usePrevious(!!queryProp);
  useEffect(function() {
  }, [defaultQuery, prevQueryPresent, queryProp, isFirstRender]);
};
var useDeprecatedProps = function useDeprecatedProps2(type, newPropPresent) {
  useEffect(function() {
  }, [newPropPresent, type]);
};
var getVm = function getVm2() {
  return hooks.inject("queryBuilderRoot");
};
var QueryBuilderContext = function QueryBuilderContext2(name) {
  var queryBuilderRoot = getVm();
  if (!queryBuilderRoot._provideData) {
    queryBuilderRoot._provideData = hooks.reactive({});
  }
  var value2 = name ? queryBuilderRoot._provideData[name] : queryBuilderRoot._provideData;
  return value2;
};
var __vue2_script$e = defineComponent({
  components: {
    TinyButton: Button
  },
  props: {
    props: Object,
    // 自定义属性，优先级高，可覆盖其他已设置属性
    className: {
      type: String
    },
    handleOnClick: {
      type: Function,
      default: function _default() {
        return;
      }
    },
    label: {
      type: String
    },
    title: {
      type: String,
      default: ""
    },
    disabled: {
      type: Boolean,
      default: false
    },
    disabledTranslation: {
      type: Object || void 0
    },
    testID: {
      type: String
    }
  },
  setup: function setup(props, context) {
    return _setup({
      props,
      context,
      renderless,
      api
    });
  },
  computed: {
    allProps: function allProps() {
      var className = this.className, title = this.title, disabled = this.disabled, disabledTranslation = this.disabledTranslation, testID = this.testID, props = this.props;
      var commonClass = "query-builder-button";
      return _extends({
        class: className ? commonClass + " " + commonClass : commonClass,
        type: "text",
        title: disabledTranslation && disabled ? disabledTranslation.title : title,
        disabled: disabled && !disabledTranslation,
        disabledTranslation,
        testID
      }, props);
    }
  }
});
var render$e = function render$e2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("tiny-button", _vm._b({
    on: {
      "click": _vm.handleOnClick
    }
  }, "tiny-button", _vm.allProps, false), [_vm._t("default", function() {
    return [_vm._v(_vm._s(_vm.disabledTranslation && _vm.disabled ? _vm.disabledTranslation.label : _vm.label))];
  })], 2);
};
var staticRenderFns$e = [];
var __cssModules$e = {};
var __component__$e = /* @__PURE__ */ normalizeComponent(__vue2_script$e, render$e, staticRenderFns$e, false, __vue2_injectStyles$e, null, null, null);
function __vue2_injectStyles$e(context) {
  for (var o in __cssModules$e) {
    this[o] = __cssModules$e[o];
  }
}
var ActionElement = /* @__PURE__ */ function() {
  return __component__$e.exports;
}();
var isOptionGroupArray = function isOptionGroupArray2(arr) {
  return Array.isArray(arr) && arr.length > 0 && "options" in arr[0];
};
var getOption = function getOption2(arr, name) {
  return (isOptionGroupArray(arr) ? arr.flatMap(function(og) {
    return og.options;
  }) : arr).find(function(op) {
    return op.name === name;
  });
};
var getFirstOption = function getFirstOption2(arr) {
  return !Array.isArray(arr) || arr.length === 0 ? null : isOptionGroupArray(arr) ? arr[0].options[0].name : arr[0].name;
};
var __vue2_script$d = defineComponent({
  components: {
    TinySelect: Select,
    TinyOption: Option,
    TinyOptionGroup: OptionGroup
  },
  props: ["className", "handleOnChange", "options", "title", "value", "multiple", "listsAsArrays", "disabled", "testID"],
  setup: function setup2() {
    return {
      isOptionGroupArray
    };
  },
  computed: {
    valueSelector: function valueSelector() {
      var handleOnChange = this.handleOnChange, value2 = this.value, multiple = this.multiple, listsAsArrays = this.listsAsArrays;
      return useValueSelector({
        handleOnChange,
        listsAsArrays,
        multiple,
        value: value2
      });
    },
    selectElementChangeHandler: function selectElementChangeHandler() {
      var onChange = this.valueSelector.onChange;
      var multiple = this.multiple;
      return useSelectElementChangeHandler({
        multiple,
        onChange
      });
    }
  },
  methods: {
    isSelected: function isSelected(data3, value2) {
      return Array.isArray(data3) ? data3.includes(value2) : data3 === value2;
    }
  }
});
var render$d = function render$d2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("tiny-select", {
    class: _vm.className + " query-builder-select",
    attrs: {
      "data-testid": _vm.testID,
      "value": _vm.valueSelector.val,
      "title": _vm.title,
      "disabled": _vm.disabled,
      "multiple": !!_vm.multiple,
      "hover-expand": ""
    },
    on: {
      "change": _vm.selectElementChangeHandler
    },
    model: {
      value: _vm.valueSelector.val,
      callback: function callback($$v) {
        _vm.$set(_vm.valueSelector, "val", $$v);
      },
      expression: "valueSelector.val"
    }
  }, [_vm.isOptionGroupArray(_vm.options) ? _vm._l(_vm.options, function(og) {
    return _c("tiny-option-group", {
      key: og.label,
      attrs: {
        "label": og.label
      }
    }, _vm._l(og.options, function(opt) {
      return _c("tiny-option", {
        key: opt.name,
        attrs: {
          "value": opt.name,
          "label": opt.label,
          "selected": _vm.isSelected(_vm.value, opt.name)
        }
      });
    }), 1);
  }) : [Array.isArray(_vm.options) ? _vm._l(_vm.options, function(opt) {
    return _c("tiny-option", {
      key: opt.name,
      attrs: {
        "value": opt.name,
        "label": opt.label
      }
    });
  }) : _vm._e()]], 2);
};
var staticRenderFns$d = [];
var __cssModules$d = {};
var __component__$d = /* @__PURE__ */ normalizeComponent(__vue2_script$d, render$d, staticRenderFns$d, false, __vue2_injectStyles$d, null, null, null);
function __vue2_injectStyles$d(context) {
  for (var o in __cssModules$d) {
    this[o] = __cssModules$d[o];
  }
}
var ValueSelector = /* @__PURE__ */ function() {
  return __component__$d.exports;
}();
var __vue2_script$c = defineComponent({
  props: ["component", "independentCombinators", "rules", "options", "value", "handleOnChange", "className", "path", "level", "title", "disabled", "context", "validation", "testID", "schema"],
  setup: function setup3() {
    return {
      standardClassnames,
      TestID
    };
  },
  computed: {
    otherProps: function otherProps() {
      var otherProps2 = _extends({}, this.$props);
      delete otherProps2.component;
      delete otherProps2.independentCombinators;
      return otherProps2;
    },
    CombinatorSelectorComponent: function CombinatorSelectorComponent() {
      return ValueSelector;
    }
  }
});
var render$c = function render$c2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    class: _vm.standardClassnames.betweenRules,
    attrs: {
      "data-testid": _vm.TestID.inlineCombinator
    }
  }, [_c(_vm.CombinatorSelectorComponent, _vm._b({
    tag: "component",
    attrs: {
      "testID": _vm.TestID.combinators
    }
  }, "component", _vm.otherProps, false))], 1);
};
var staticRenderFns$c = [];
var __cssModules$c = {};
var __component__$c = /* @__PURE__ */ normalizeComponent(__vue2_script$c, render$c, staticRenderFns$c, false, __vue2_injectStyles$c, null, null, null);
function __vue2_injectStyles$c(context) {
  for (var o in __cssModules$c) {
    this[o] = __cssModules$c[o];
  }
}
var InlineCombinator = /* @__PURE__ */ function() {
  return __component__$c.exports;
}();
var __vue2_script$b = defineComponent({
  components: {
    TinyCheckbox: Checkbox
  },
  props: {
    className: {
      type: String
    },
    handleOnChange: {
      type: Function
    },
    title: {
      type: String,
      default: ""
    },
    label: {
      type: String
    },
    checked: {
      type: Boolean,
      default: false
    },
    disabled: {
      type: Boolean,
      default: false
    },
    testID: {
      type: String
    }
  },
  setup: function setup4(props) {
    return {
      value: props.checked
    };
  },
  watch: {
    checked: function checked() {
      this.value = this.checked;
    }
  }
});
var render$b = function render$b2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("tiny-checkbox", {
    class: _vm.className,
    attrs: {
      "disabled": _vm.disabled,
      "data-testid": _vm.testID,
      "title": _vm.title
    },
    on: {
      "change": function change2($event) {
        return _vm.handleOnChange(_vm.value);
      }
    },
    model: {
      value: _vm.value,
      callback: function callback($$v) {
        _vm.value = $$v;
      },
      expression: "value"
    }
  }, [_vm._v(_vm._s(_vm.label))]);
};
var staticRenderFns$b = [];
var __cssModules$b = {};
var __component__$b = /* @__PURE__ */ normalizeComponent(__vue2_script$b, render$b, staticRenderFns$b, false, __vue2_injectStyles$b, null, null, null);
function __vue2_injectStyles$b(context) {
  for (var o in __cssModules$b) {
    this[o] = __cssModules$b[o];
  }
}
var NotToggle = /* @__PURE__ */ function() {
  return __component__$b.exports;
}();
var RulePropsParam$1 = ["rule", "field", "operator", "value", "valueSource", "id", "path", "parentDisabled", "translations", "schema", "actions", "disabled", "context", "isDragging", "dragMonitorId", "isOver", "dropMonitorId", "dragRef", "dndRef", "dropEffect"];
var UseRuleProps = ["classNames", "cloneRule", "fieldData", "generateOnChangeHandler", "hideValueControls", "inputType", "operators", "outerClassName", "removeRule", "clearData", "toggleLockRule", "validationResult", "valueEditorSeparator", "valueEditorType", "values", "valueSourceOptions", "onlyOne", "valueSources"];
var __vue2_script$a = defineComponent({
  name: "RuleComponents",
  components: {
    IconNodeOpen: IconNodeOpen(),
    IconEditorEraser: IconEditorEraser()
  },
  inject: ["queryBuilderRoot"],
  props: [].concat(RulePropsParam$1, UseRuleProps),
  //:RuleComponents
  setup: function setup5() {
    return {
      TestID
    };
  },
  computed: {
    r: function r() {
      return _extends({}, this.$props);
    },
    controls: function controls() {
      var _this$r$schema$contro = this.r.schema.controls, dragHandle = _this$r$schema$contro.dragHandle, fieldSelector = _this$r$schema$contro.fieldSelector, operatorSelector = _this$r$schema$contro.operatorSelector, valueSourceSelector = _this$r$schema$contro.valueSourceSelector, valueEditor = _this$r$schema$contro.valueEditor, cloneRuleAction = _this$r$schema$contro.cloneRuleAction, lockRuleAction = _this$r$schema$contro.lockRuleAction, clearRuleAction = _this$r$schema$contro.clearRuleAction, removeRuleAction = _this$r$schema$contro.removeRuleAction, clearDataAction = _this$r$schema$contro.clearDataAction;
      return {
        dragHandle,
        fieldSelector,
        operatorSelector,
        valueSourceSelector,
        valueEditor,
        cloneRuleAction,
        lockRuleAction,
        clearRuleAction,
        removeRuleAction,
        clearDataAction
      };
    }
  }
});
var render$a = function render$a2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "rule--wrap"
  }, [_vm.r.schema.enableDragAndDrop ? _c(_vm.controls.dragHandle, {
    ref: _vm.r.dragRef,
    tag: "component",
    attrs: {
      "testID": _vm.TestID.dragHandle,
      "level": _vm.r.path.length,
      "path": _vm.r.path,
      "title": _vm.r.translations.dragHandle.title,
      "label": _vm.r.translations.dragHandle.label,
      "className": _vm.r.classNames.dragHandle,
      "disabled": _vm.r.disabled,
      "context": _vm.r.context,
      "validation": _vm.r.validationResult,
      "schema": _vm.r.schema
    }
  }) : _vm._e(), _c(_vm.controls.fieldSelector, {
    tag: "component",
    attrs: {
      "testID": _vm.TestID.fields,
      "options": _vm.r.schema.fields,
      "title": _vm.r.translations.fields.title,
      "value": _vm.r.rule.field,
      "operator": _vm.r.rule.operator,
      "className": _vm.r.classNames.fields,
      "handleOnChange": _vm.r.generateOnChangeHandler("field"),
      "level": _vm.r.path.length,
      "path": _vm.r.path,
      "disabled": _vm.r.disabled,
      "context": _vm.r.context,
      "validation": _vm.r.validationResult,
      "schema": _vm.r.schema
    }
  }), _vm.r.schema.autoSelectField || _vm.r.rule.field !== _vm.r.translations.fields.placeholderName ? _c(_vm.controls.operatorSelector, {
    tag: "component",
    attrs: {
      "testID": _vm.TestID.operators,
      "field": _vm.r.rule.field,
      "fieldData": _vm.r.fieldData,
      "title": _vm.r.translations.operators.title,
      "options": _vm.r.operators,
      "value": _vm.r.rule.operator,
      "className": _vm.r.classNames.operators,
      "handleOnChange": _vm.r.generateOnChangeHandler("operator"),
      "level": _vm.r.path.length,
      "path": _vm.r.path,
      "disabled": _vm.r.disabled,
      "context": _vm.r.context,
      "validation": _vm.r.validationResult,
      "schema": _vm.r.schema
    }
  }) : _vm._e(), (_vm.r.schema.autoSelectOperator || _vm.r.rule.operator !== _vm.r.translations.operators.placeholderName) && !_vm.r.hideValueControls ? [!["null", "notNull"].includes(_vm.r.rule.operator) && _vm.r.valueSources.length > 1 ? _c(_vm.controls.valueSourceSelector, {
    tag: "component",
    attrs: {
      "testID": _vm.TestID.valueSourceSelector,
      "field": _vm.r.rule.field,
      "fieldData": _vm.r.fieldData,
      "title": _vm.r.translations.valueSourceSelector.title,
      "options": _vm.r.valueSourceOptions,
      "value": _vm.r.rule.valueSource == void 0 || null ? "value" : _vm.r.rule.valueSource,
      "className": _vm.r.classNames.valueSource,
      "handleOnChange": _vm.r.generateOnChangeHandler("valueSource"),
      "level": _vm.r.path.length,
      "path": _vm.r.path,
      "disabled": _vm.r.disabled,
      "context": _vm.r.context,
      "validation": _vm.r.validationResult,
      "schema": _vm.r.schema
    }
  }) : _vm._e(), _c(_vm.controls.valueEditor, {
    tag: "component",
    attrs: {
      "testID": _vm.TestID.valueEditor,
      "field": _vm.r.rule.field,
      "fieldData": _vm.r.fieldData,
      "title": _vm.r.translations.title,
      "operator": _vm.r.rule.operator,
      "value": _vm.r.rule.value,
      "valueSource": _vm.r.rule.valueSource == void 0 || null ? "value" : _vm.r.rule.valueSource,
      "type": _vm.r.valueEditorType,
      "inputType": _vm.r.inputType,
      "values": _vm.r.values,
      "listsAsArrays": _vm.r.schema.listsAsArrays,
      "parseNumbers": _vm.r.schema.parseNumbers,
      "separator": _vm.r.valueEditorSeparator,
      "className": _vm.r.classNames.value,
      "handleOnChange": _vm.r.generateOnChangeHandler("value"),
      "level": _vm.r.path.length,
      "path": _vm.r.path,
      "disabled": _vm.r.disabled,
      "context": _vm.r.context,
      "validation": _vm.r.validationResult,
      "schema": _vm.r.schema
    }
  })] : _vm._e(), _vm.r.schema.showCloneButtons ? _c(_vm.controls.cloneRuleAction, {
    tag: "component",
    attrs: {
      "testID": _vm.TestID.cloneRule,
      "label": _vm.r.translations.cloneRule.label,
      "title": _vm.r.translations.cloneRule.title,
      "className": _vm.r.classNames.cloneRule,
      "handleOnClick": _vm.r.cloneRule,
      "level": _vm.r.path.length,
      "path": _vm.r.path,
      "disabled": _vm.r.disabled,
      "context": _vm.r.context,
      "validation": _vm.r.validationResult,
      "ruleOrGroup": _vm.r.rule,
      "schema": _vm.r.schema
    }
  }, [_c("span", {
    staticClass: "btn-font"
  }, [_vm._v("⧉")])]) : _vm._e(), _vm.r.schema.showLockButtons ? _c(_vm.controls.lockRuleAction, {
    tag: "component",
    attrs: {
      "testID": _vm.TestID.lockRule,
      "label": _vm.r.translations.lockRule.label,
      "title": _vm.r.translations.lockRule.title,
      "className": _vm.r.classNames.lockRule,
      "handleOnClick": _vm.r.toggleLockRule,
      "level": _vm.r.path.length,
      "path": _vm.r.path,
      "disabled": _vm.r.disabled,
      "disabledTranslation": _vm.r.parentDisabled ? void 0 : _vm.r.translations.lockRuleDisabled,
      "context": _vm.r.context,
      "validation": _vm.r.validationResult,
      "ruleOrGroup": _vm.r.rule,
      "schema": _vm.r.schema
    }
  }, [_c("span", {
    staticClass: "btn-font"
  }, [_vm._v("🔓")])]) : _vm._e(), _vm.queryBuilderRoot.showClearBtn ? _c(_vm.controls.clearDataAction, {
    tag: "component",
    attrs: {
      "testID": _vm.TestID.clearData,
      "label": _vm.r.translations.clearData.label,
      "title": _vm.r.translations.clearData.title,
      "className": _vm.r.classNames.clearData,
      "handleOnClick": _vm.r.clearData,
      "level": _vm.r.path.length,
      "path": _vm.r.path,
      "disabled": _vm.r.disabled,
      "context": _vm.r.context,
      "validation": _vm.r.validationResult,
      "ruleOrGroup": _vm.r.rule,
      "schema": _vm.r.schema
    }
  }, [_c("IconEditorEraser", {
    staticClass: "btn-icon"
  })], 1) : _c(_vm.controls.removeRuleAction, {
    tag: "component",
    attrs: {
      "testID": _vm.TestID.removeRule,
      "label": _vm.r.translations.removeRule.label,
      "title": _vm.r.translations.removeRule.title,
      "className": _vm.r.classNames.removeRule,
      "handleOnClick": _vm.r.removeRule,
      "level": _vm.r.path.length,
      "path": _vm.r.path,
      "disabled": _vm.r.disabled,
      "context": _vm.r.context,
      "validation": _vm.r.validationResult,
      "ruleOrGroup": _vm.r.rule,
      "schema": _vm.r.schema
    }
  }, [_c("IconNodeOpen", {
    staticClass: "btn-icon"
  })], 1)], 2);
};
var staticRenderFns$a = [];
var __cssModules$a = {};
var __component__$a = /* @__PURE__ */ normalizeComponent(__vue2_script$a, render$a, staticRenderFns$a, false, __vue2_injectStyles$a, null, null, null);
function __vue2_injectStyles$a(context) {
  for (var o in __cssModules$a) {
    this[o] = __cssModules$a[o];
  }
}
var RuleComponents = /* @__PURE__ */ function() {
  return __component__$a.exports;
}();
var RulePropsParam = ["rule", "field", "operator", "value", "valueSource", "id", "path", "parentDisabled", "translations", "schema", "actions", "disabled", "context", "isDragging", "dragMonitorId", "isOver", "dropMonitorId", "dragRef", "dndRef", "onlyOne", "dropEffect"];
var __vue2_script$9 = defineComponent({
  name: "Rule",
  components: {
    RuleComponents
  },
  props: [].concat(RulePropsParam),
  // :RuleProps
  setup: function setup6() {
    return {
      TestID
    };
  },
  computed: {
    r: function r2() {
      return _extends({}, this.$props, useRule(this.$props));
    },
    RuleComponentProps: function RuleComponentProps() {
      var r3 = this.r;
      var _map = [r3.cloneRule, r3.toggleLockRule, r3.removeRule, r3.clearData].map(function(f) {
        return function(event) {
          event.preventDefault();
          event.stopPropagation();
          f();
        };
      }), cloneRule = _map[0], toggleLockRule = _map[1], removeRule = _map[2], clearData = _map[3];
      return _extends({}, this.r, {
        cloneRule,
        toggleLockRule,
        removeRule,
        clearData
      });
    }
  }
});
var render$9 = function render$92() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    ref: _vm.r.dndRef,
    class: _vm.r.outerClassName,
    attrs: {
      "data-testid": _vm.TestID.rule,
      "data-dragmonitorid": _vm.r.dragMonitorId,
      "data-dropmonitorid": _vm.r.dropMonitorId,
      "data-rule-id": _vm.r.id,
      "data-level": _vm.r.path.length,
      "data-path": JSON.stringify(_vm.r.path)
    }
  }, [_c("RuleComponents", _vm._b({}, "RuleComponents", _vm.RuleComponentProps, false))], 1);
};
var staticRenderFns$9 = [];
var __cssModules$9 = {};
var __component__$9 = /* @__PURE__ */ normalizeComponent(__vue2_script$9, render$9, staticRenderFns$9, false, __vue2_injectStyles$9, null, null, null);
function __vue2_injectStyles$9(context) {
  for (var o in __cssModules$9) {
    this[o] = __cssModules$9[o];
  }
}
var Rule = /* @__PURE__ */ function() {
  return __component__$9.exports;
}();
var RuleGroupProps$1 = ["ruleGroup", "combinator", "rules", "not", "id", "path", "parentDisabled", "translations", "schema", "actions", "disabled", "context", "isDragging", "dragMonitorId", "isOver", "dropMonitorId", "previewRef", "dragRef", "dropRef", "dropEffect", "addGroup", "addRule", "classNames", "cloneGroup", "onCombinatorChange", "onGroupAdd", "onIndependentCombinatorChange", "onNotToggleChange", "outerClassName", "removeGroup", "toggleLockGroup", "validationClassName", "onlyOne", "validationResult"];
var __vue2_script$8 = defineComponent({
  name: "RuleGroupBodyComponents",
  props: [].concat(RuleGroupProps$1),
  // :RuleGroupProps
  setup: function setup7() {
    return {
      TestID
    };
  },
  computed: {
    rg: function rg() {
      return _extends({}, this.$props);
    },
    controls: function controls2() {
      var _this$rg$schema$contr = this.rg.schema.controls, inlineCombinator = _this$rg$schema$contr.inlineCombinator, ruleGroup2 = _this$rg$schema$contr.ruleGroup, rule = _this$rg$schema$contr.rule;
      return {
        inlineCombinator,
        ruleGroup: ruleGroup2,
        rule
      };
    },
    getFields: function getFields() {
      var _this = this;
      return this.rg.ruleGroup.rules.map(function(r3, idx) {
        var rg3 = _this.rg;
        var thisPath = [].concat(rg3.path, [idx]);
        var thisPathDisabled = rg3.disabled || typeof r3 !== "string" && r3.disabled || rg3.schema.disabledPaths.some(function(p) {
          return pathsAreEqual(thisPath, p);
        });
        var key = typeof r3 === "string" ? [].concat(thisPath, [r3]).join("-") : r3.id;
        return {
          thisPathDisabled,
          key,
          thisPath
        };
      });
    }
  }
});
var render$8 = function render$82() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    class: _vm.rg.classNames.body
  }, _vm._l(_vm.rg.ruleGroup.rules, function(r3, idx) {
    return _c("div", {
      key: _vm.getFields[idx].key
    }, [idx > 0 && !_vm.rg.schema.independentCombinators && _vm.rg.schema.showCombinatorsBetweenRules ? _c(_vm.controls.inlineCombinator, {
      tag: "component",
      attrs: {
        "options": _vm.rg.schema.combinators,
        "value": _vm.rg.combinator,
        "title": _vm.rg.translations.combinators.title,
        "className": _vm.rg.classNames.combinators,
        "handleOnChange": _vm.rg.onCombinatorChange,
        "rules": _vm.rg.ruleGroup.rules,
        "level": _vm.rg.path.length,
        "context": _vm.rg.context,
        "validation": _vm.rg.validationResult,
        "component": _vm.controls.combinatorSelector,
        "path": _vm.getFields[idx].thisPath,
        "disabled": _vm.rg.disabled,
        "independentCombinators": _vm.rg.schema.independentCombinators,
        "schema": _vm.rg.schema
      }
    }) : _vm._e(), typeof r3 === "string" ? _c(_vm.controls.inlineCombinator, {
      tag: "component",
      attrs: {
        "options": _vm.rg.schema.combinators,
        "value": r3,
        "title": _vm.rg.translations.combinators.title,
        "className": _vm.rg.classNames.combinators,
        "handleOnChange": function handleOnChange(val) {
          return _vm.rg.onIndependentCombinatorChange(val, idx);
        },
        "rules": _vm.rg.ruleGroup.rules,
        "level": _vm.rg.path.length,
        "context": _vm.rg.context,
        "validation": _vm.rg.validationResult,
        "component": _vm.CombinatorSelectorControlElement,
        "path": _vm.getFields[idx].thisPath,
        "disabled": _vm.getFields[idx].thisPathDisabled,
        "independentCombinators": _vm.rg.schema.independentCombinators,
        "schema": _vm.rg.schema
      }
    }) : "rules" in r3 ? _c(_vm.controls.ruleGroup, {
      tag: "component",
      attrs: {
        "id": r3.id,
        "schema": _vm.rg.schema,
        "actions": _vm.rg.actions,
        "path": _vm.getFields[idx].thisPath,
        "translations": _vm.rg.translations,
        "ruleGroup": r3,
        "rules": r3.rules,
        "combinator": "combinator" in r3 ? r3.combinator : void 0,
        "not": !!r3.not,
        "disabled": _vm.getFields[idx].thisPathDisabled,
        "parentDisabled": _vm.rg.parentDisabled || _vm.rg.disabled,
        "context": _vm.rg.context
      }
    }) : _c(_vm.controls.rule, {
      tag: "component",
      attrs: {
        "id": r3.id,
        "rule": r3,
        "field": r3.field,
        "operator": r3.operator,
        "value": r3.value,
        "valueSource": r3.valueSource,
        "schema": _vm.rg.schema,
        "actions": _vm.rg.actions,
        "path": _vm.getFields[idx].thisPath,
        "disabled": _vm.getFields[idx].thisPathDisabled,
        "parentDisabled": _vm.rg.parentDisabled || _vm.rg.disabled,
        "translations": _vm.rg.translations,
        "context": _vm.rg.context,
        "onlyOne": _vm.onlyOne
      }
    })], 1);
  }), 0);
};
var staticRenderFns$8 = [];
var __cssModules$8 = {};
var __component__$8 = /* @__PURE__ */ normalizeComponent(__vue2_script$8, render$8, staticRenderFns$8, false, __vue2_injectStyles$8, null, null, null);
function __vue2_injectStyles$8(context) {
  for (var o in __cssModules$8) {
    this[o] = __cssModules$8[o];
  }
}
var RuleGroupBodyComponents = /* @__PURE__ */ function() {
  return __component__$8.exports;
}();
var RuleGroupProps = ["ruleGroup", "combinator", "rules", "not", "id", "path", "parentDisabled", "translations", "schema", "actions", "disabled", "context", "isDragging", "dragMonitorId", "isOver", "dropMonitorId", "previewRef", "dragRef", "dropRef", "dropEffect", "addGroup", "addRule", "classNames", "cloneGroup", "onCombinatorChange", "onGroupAdd", "onIndependentCombinatorChange", "onNotToggleChange", "outerClassName", "removeGroup", "toggleLockGroup", "validationClassName", "validationResult"];
var __vue2_script$7 = defineComponent({
  name: "RuleGroup",
  components: {
    RuleGroupBodyComponents,
    IconPlus: IconPlus(),
    IconDel: IconDel(),
    IconNodeOpen: IconNodeOpen(),
    IconNode: IconNode()
  },
  props: [].concat(RuleGroupProps),
  // :RuleGroupProps
  setup: function setup8() {
    return {
      TestID
    };
  },
  computed: {
    rg: function rg2() {
      return _extends({}, this.$props, useRuleGroup(this.$props));
    },
    subComponentProps: function subComponentProps() {
      var rg3 = this.rg;
      var _map2 = [rg3.addRule, rg3.addGroup, rg3.cloneGroup, rg3.toggleLockGroup, rg3.removeGroup].map(function(f) {
        return function(event, context) {
          event.preventDefault();
          event.stopPropagation();
          f(event, context);
        };
      }), addRule = _map2[0], addGroup = _map2[1], cloneGroup = _map2[2], toggleLockGroup = _map2[3], removeGroup = _map2[4];
      return _extends({}, this.rg, {
        addRule,
        addGroup,
        cloneGroup,
        toggleLockGroup,
        removeGroup,
        onlyOne: this.onlyOne
      });
    },
    controls: function controls3() {
      var _this$rg$schema$contr2 = this.rg.schema.controls, dragHandle = _this$rg$schema$contr2.dragHandle, combinatorSelector = _this$rg$schema$contr2.combinatorSelector, notToggle = _this$rg$schema$contr2.notToggle, addRuleAction = _this$rg$schema$contr2.addRuleAction, addGroupAction = _this$rg$schema$contr2.addGroupAction, cloneGroupAction = _this$rg$schema$contr2.cloneGroupAction, lockGroupAction = _this$rg$schema$contr2.lockGroupAction, removeGroupAction = _this$rg$schema$contr2.removeGroupAction;
      return {
        dragHandle,
        combinatorSelector,
        notToggle,
        addRuleAction,
        addGroupAction,
        cloneGroupAction,
        lockGroupAction,
        removeGroupAction
      };
    },
    onlyOne: function onlyOne() {
      return this.rg.ruleGroup.rules.length <= 1;
    }
  }
});
var render$7 = function render$72() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    ref: _vm.rg.previewRef,
    class: _vm.rg.outerClassName + (_vm.onlyOne ? " .only-one" : ""),
    attrs: {
      "data-testid": _vm.TestID.ruleGroup,
      "data-dragmonitorid": _vm.rg.dragMonitorId,
      "data-dropmonitorid": _vm.rg.dropMonitorId,
      "data-rule-group-id": _vm.rg.id,
      "data-level": _vm.rg.path.length,
      "data-path": JSON.stringify(_vm.rg.path)
    }
  }, [_c("div", {
    staticClass: "group-rule-branches"
  }, [!_vm.rg.schema.showCombinatorsBetweenRules && !_vm.rg.schema.independentCombinators && !_vm.onlyOne ? _c(_vm.controls.combinatorSelector, {
    tag: "component",
    attrs: {
      "testID": _vm.TestID.combinators,
      "options": _vm.rg.schema.combinators,
      "value": _vm.rg.combinator,
      "title": _vm.rg.translations.combinators.title,
      "className": _vm.rg.classNames.combinators,
      "handleOnChange": _vm.rg.onCombinatorChange,
      "rules": _vm.rg.ruleGroup.rules,
      "level": _vm.rg.path.length,
      "path": _vm.rg.path,
      "disabled": _vm.rg.disabled,
      "context": _vm.rg.context,
      "validation": _vm.rg.validationResult,
      "schema": _vm.rg.schema
    }
  }) : _vm._e()], 1), _c("div", {
    staticClass: "group-rule-body"
  }, [_c("RuleGroupBodyComponents", _vm._b({}, "RuleGroupBodyComponents", _vm.subComponentProps, false)), _c("div", {
    ref: _vm.rg.dropRef,
    class: _vm.rg.classNames.header
  }, [_c("div", {
    staticClass: "rule-group--wrap"
  }, [_vm.rg.path.length > 0 && _vm.rg.schema.enableDragAndDrop ? _c(_vm.controls.dragHandle, {
    ref: _vm.rg.dragRef,
    tag: "component",
    attrs: {
      "testID": _vm.TestID.dragHandle,
      "level": _vm.rg.path.length,
      "path": _vm.rg.path,
      "title": _vm.rg.translations.dragHandle.title,
      "label": _vm.rg.translations.dragHandle.label,
      "className": _vm.rg.classNames.dragHandle,
      "disabled": _vm.rg.disabled,
      "context": _vm.rg.context,
      "validation": _vm.rg.validationResult,
      "schema": _vm.rg.schema
    }
  }) : _vm._e(), _vm.rg.schema.showNotToggle ? _c(_vm.controls.notToggle, {
    tag: "component",
    attrs: {
      "testID": _vm.TestID.notToggle,
      "className": _vm.rg.classNames.notToggle,
      "title": _vm.rg.translations.notToggle.title,
      "label": _vm.rg.translations.notToggle.label,
      "checked": _vm.rg.ruleGroup.not,
      "handleOnChange": _vm.rg.onNotToggleChange,
      "level": _vm.rg.path.length,
      "disabled": _vm.rg.disabled,
      "path": _vm.rg.path,
      "context": _vm.rg.context,
      "validation": _vm.rg.validationResult,
      "schema": _vm.rg.schema
    }
  }) : _vm._e(), _c(_vm.controls.addRuleAction, {
    tag: "component",
    attrs: {
      "testID": _vm.TestID.addRule,
      "label": _vm.rg.translations.addRule.label,
      "title": _vm.rg.translations.addRule.title,
      "className": _vm.rg.classNames.addRule,
      "handleOnClick": _vm.rg.addRule,
      "rules": _vm.rg.ruleGroup.rules,
      "level": _vm.rg.path.length,
      "path": _vm.rg.path,
      "disabled": _vm.rg.disabled,
      "context": _vm.rg.context,
      "validation": _vm.rg.validationResult,
      "ruleOrGroup": _vm.rg.ruleGroup,
      "schema": _vm.rg.schema
    }
  }, [_c("IconPlus", {
    staticClass: "primary-svg"
  }), _vm._v(" 新增条件 ")], 1), _c(_vm.controls.addGroupAction, {
    tag: "component",
    attrs: {
      "testID": _vm.TestID.addGroup,
      "label": _vm.rg.translations.addGroup.label,
      "title": _vm.rg.translations.addGroup.title,
      "className": _vm.rg.classNames.addGroup,
      "handleOnClick": _vm.rg.addGroup,
      "rules": _vm.rg.ruleGroup.rules,
      "level": _vm.rg.path.length,
      "path": _vm.rg.path,
      "disabled": _vm.rg.disabled,
      "context": _vm.rg.context,
      "validation": _vm.rg.validationResult,
      "ruleOrGroup": _vm.rg.ruleGroup,
      "schema": _vm.rg.schema
    }
  }, [_c("IconPlus", {
    staticClass: "primary-svg"
  }), _vm._v(" 新增子条件组")], 1), _vm.rg.path.length >= 1 ? _c(_vm.controls.removeGroupAction, {
    tag: "component",
    attrs: {
      "testID": _vm.TestID.removeGroup,
      "label": _vm.rg.translations.removeGroup.label,
      "title": _vm.rg.translations.removeGroup.title,
      "className": _vm.rg.classNames.removeGroup,
      "handleOnClick": _vm.rg.removeGroup,
      "rules": _vm.rg.ruleGroup.rules,
      "level": _vm.rg.path.length,
      "path": _vm.rg.path,
      "disabled": _vm.rg.disabled,
      "context": _vm.rg.context,
      "validation": _vm.rg.validationResult,
      "ruleOrGroup": _vm.rg.ruleGroup,
      "schema": _vm.rg.schema
    }
  }, [_c("IconDel", {
    staticClass: "primary-svg"
  }), _vm._v(" 移除条件组")], 1) : _vm._e(), _vm.rg.schema.showCloneButtons && _vm.rg.path.length >= 1 ? _c(_vm.controls.cloneGroupAction, {
    tag: "component",
    attrs: {
      "testID": _vm.TestID.cloneGroup,
      "label": _vm.rg.translations.cloneRuleGroup.label,
      "title": _vm.rg.translations.cloneRuleGroup.title,
      "className": _vm.rg.classNames.cloneGroup,
      "handleOnClick": _vm.rg.cloneGroup,
      "rules": _vm.rg.ruleGroup.rules,
      "level": _vm.rg.path.length,
      "path": _vm.rg.path,
      "disabled": _vm.rg.disabled,
      "context": _vm.rg.context,
      "validation": _vm.rg.validationResult,
      "ruleOrGroup": _vm.rg.ruleGroup,
      "schema": _vm.rg.schema
    }
  }, [_c("span", {
    staticClass: "btn-icon"
  }, [_vm._v("⧉")])]) : _vm._e(), _vm.rg.schema.showLockButtons ? _c(_vm.controls.lockGroupAction, {
    tag: "component",
    attrs: {
      "testID": _vm.TestID.lockGroup,
      "label": _vm.rg.translations.lockGroup.label,
      "title": _vm.rg.translations.lockGroup.title,
      "className": _vm.rg.classNames.lockGroup,
      "handleOnClick": _vm.rg.toggleLockGroup,
      "rules": _vm.rg.ruleGroup.rules,
      "level": _vm.rg.path.length,
      "path": _vm.rg.path,
      "disabled": _vm.rg.disabled,
      "disabledTranslation": _vm.rg.parentDisabled ? void 0 : _vm.rg.translations.lockGroupDisabled,
      "context": _vm.rg.context,
      "validation": _vm.rg.validationResult,
      "ruleOrGroup": _vm.rg.ruleGroup,
      "schema": _vm.rg.schema
    }
  }) : _vm._e()], 1)])], 1), _c("div", {
    staticClass: "group-rule-action"
  })]);
};
var staticRenderFns$7 = [];
var __cssModules$7 = {};
var __component__$7 = /* @__PURE__ */ normalizeComponent(__vue2_script$7, render$7, staticRenderFns$7, false, __vue2_injectStyles$7, null, null, null);
function __vue2_injectStyles$7(context) {
  for (var o in __cssModules$7) {
    this[o] = __cssModules$7[o];
  }
}
var RuleGroup = /* @__PURE__ */ function() {
  return __component__$7.exports;
}();
var __vue2_script$6 = defineComponent({
  components: {
    TinyInput: Input$1,
    TinyNumeric: Numeric,
    TinyDatePicker: DatePicker,
    TinyTimePicker: TimePicker,
    TinyCheckbox: Checkbox,
    TinyRadio: Radio
  },
  props: {
    value: {},
    type: {
      type: String,
      default: "text"
    },
    props: Object,
    events: Object
  },
  data: function data() {
    return {
      modelValue: this.value
    };
  },
  watch: {
    value: function value(_value) {
      this.modelValue = _value;
    }
  },
  methods: {
    update: function update() {
      this.$emit("update:modelValue", this.modelValue);
    }
  }
});
var render$6 = function render$62() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return ["text", "textarea"].includes(_vm.type) ? _c("tiny-input", _vm._g(_vm._b({
    attrs: {
      "type": _vm.type
    },
    on: {
      "update:modelValue": _vm.update
    },
    model: {
      value: _vm.modelValue,
      callback: function callback($$v) {
        _vm.modelValue = $$v;
      },
      expression: "modelValue"
    }
  }, "tiny-input", _vm.props, false), _vm.events)) : _vm.type === "number" ? _c("tiny-numeric", _vm._g(_vm._b({
    on: {
      "update:modelValue": _vm.update
    },
    model: {
      value: _vm.modelValue,
      callback: function callback($$v) {
        _vm.modelValue = $$v;
      },
      expression: "modelValue"
    }
  }, "tiny-numeric", _vm.props, false), _vm.events)) : ["date", "datetime-local"].includes(_vm.type) ? _c("tiny-date-picker", _vm._g(_vm._b({
    attrs: {
      "value-format": "yyyy-MM-dd"
    },
    on: {
      "update:modelValue": _vm.update
    },
    model: {
      value: _vm.modelValue,
      callback: function callback($$v) {
        _vm.modelValue = $$v;
      },
      expression: "modelValue"
    }
  }, "tiny-date-picker", _vm.props, false), _vm.events)) : _vm.type === "time" ? _c("tiny-time-picker", _vm._g(_vm._b({
    attrs: {
      "format": "hh:mm",
      "value-format": "shortTime"
    },
    on: {
      "update:modelValue": _vm.update
    },
    model: {
      value: _vm.modelValue,
      callback: function callback($$v) {
        _vm.modelValue = $$v;
      },
      expression: "modelValue"
    }
  }, "tiny-time-picker", _vm.props, false), _vm.events)) : _vm.type === "radio" ? _c("tiny-radio", _vm._g(_vm._b({
    on: {
      "update:modelValue": _vm.update
    },
    model: {
      value: _vm.modelValue,
      callback: function callback($$v) {
        _vm.modelValue = $$v;
      },
      expression: "modelValue"
    }
  }, "tiny-radio", _vm.props, false), _vm.events)) : _vm.type === "checkbox" ? _c("tiny-checkbox", _vm._g(_vm._b({
    on: {
      "update:modelValue": _vm.update
    },
    model: {
      value: _vm.modelValue,
      callback: function callback($$v) {
        _vm.modelValue = $$v;
      },
      expression: "modelValue"
    }
  }, "tiny-checkbox", _vm.props, false), _vm.events)) : _vm.type === "checkbox" ? _c("input", _vm._g(_vm._b({
    directives: [{
      name: "model",
      rawName: "v-model",
      value: _vm.modelValue,
      expression: "modelValue"
    }],
    attrs: {
      "type": "checkbox"
    },
    domProps: {
      "checked": Array.isArray(_vm.modelValue) ? _vm._i(_vm.modelValue, null) > -1 : _vm.modelValue
    },
    on: {
      "input": _vm.update,
      "change": function change2($event) {
        var $$a = _vm.modelValue, $$el = $event.target, $$c = $$el.checked ? true : false;
        if (Array.isArray($$a)) {
          var $$v = null, $$i = _vm._i($$a, $$v);
          if ($$el.checked) {
            $$i < 0 && (_vm.modelValue = $$a.concat([$$v]));
          } else {
            $$i > -1 && (_vm.modelValue = $$a.slice(0, $$i).concat($$a.slice($$i + 1)));
          }
        } else {
          _vm.modelValue = $$c;
        }
      }
    }
  }, "input", _vm.props, false), _vm.events)) : _vm.type === "radio" ? _c("input", _vm._g(_vm._b({
    directives: [{
      name: "model",
      rawName: "v-model",
      value: _vm.modelValue,
      expression: "modelValue"
    }],
    attrs: {
      "type": "radio"
    },
    domProps: {
      "checked": _vm._q(_vm.modelValue, null)
    },
    on: {
      "input": _vm.update,
      "change": function change2($event) {
        _vm.modelValue = null;
      }
    }
  }, "input", _vm.props, false), _vm.events)) : _c("input", _vm._g(_vm._b({
    directives: [{
      name: "model",
      rawName: "v-model",
      value: _vm.modelValue,
      expression: "modelValue"
    }],
    attrs: {
      "type": _vm.type
    },
    domProps: {
      "value": _vm.modelValue
    },
    on: {
      "input": [function($event) {
        if ($event.target.composing)
          return;
        _vm.modelValue = $event.target.value;
      }, _vm.update]
    }
  }, "input", _vm.props, false), _vm.events));
};
var staticRenderFns$6 = [];
var __cssModules$6 = {};
var __component__$6 = /* @__PURE__ */ normalizeComponent(__vue2_script$6, render$6, staticRenderFns$6, false, __vue2_injectStyles$6, null, null, null);
function __vue2_injectStyles$6(context) {
  for (var o in __cssModules$6) {
    this[o] = __cssModules$6[o];
  }
}
var Input = /* @__PURE__ */ function() {
  return __component__$6.exports;
}();
var __vue2_script$5 = defineComponent({
  components: {
    CustomInput: Input
  },
  props: {
    field: String,
    operator: {},
    value: {},
    valueSource: {},
    fieldData: {},
    type: {
      type: String,
      default: "text"
    },
    inputType: {
      type: String,
      default: "text"
    },
    values: {
      type: Array,
      default: function _default2() {
        return [];
      }
    },
    listsAsArrays: {},
    parseNumbers: {},
    separator: {},
    selectorComponent: {},
    skipHook: {},
    handleOnChange: {},
    className: {},
    path: {},
    level: {},
    title: {},
    disabled: {},
    context: {},
    validation: {},
    testID: {},
    schema: {}
  },
  // :ValueEditorProps
  setup: function setup9() {
    return {
      standardClassnames,
      getFirstOption,
      parseNumber,
      modelValue: {
        from: "",
        to: ""
      }
    };
  },
  computed: {
    allProps: function allProps2() {
      var _fieldData$placeholde;
      var _this$$props = this.$props, operator = _this$$props.operator, value2 = _this$$props.value, handleOnChange = _this$$props.handleOnChange, title = _this$$props.title, className = _this$$props.className, _this$$props$type = _this$$props.type, type = _this$$props$type === void 0 ? "text" : _this$$props$type, _this$$props$inputTyp = _this$$props.inputType, inputType = _this$$props$inputTyp === void 0 ? "text" : _this$$props$inputTyp, _this$$props$values = _this$$props.values, values = _this$$props$values === void 0 ? [] : _this$$props$values, listsAsArrays = _this$$props.listsAsArrays, parseNumbers = _this$$props.parseNumbers, fieldData = _this$$props.fieldData, disabled = _this$$props.disabled, _this$$props$separato = _this$$props.separator, separator = _this$$props$separato === void 0 ? null : _this$$props$separato, _this$$props$skipHook = _this$$props.skipHook, skipHook = _this$$props$skipHook === void 0 ? false : _this$$props$skipHook, testID = _this$$props.testID, _this$$props$selector = _this$$props.selectorComponent, SelectorComponent = _this$$props$selector === void 0 ? ValueSelector : _this$$props$selector, props = _objectWithoutPropertiesLoose(_this$$props, _excluded);
      var _useValueEditor = useValueEditor({
        skipHook,
        handleOnChange,
        inputType,
        operator,
        value: value2,
        type,
        listsAsArrays,
        parseNumbers,
        values
      }), valueAsArray = _useValueEditor.valueAsArray, multiValueHandler = _useValueEditor.multiValueHandler;
      var placeHolderText = (_fieldData$placeholde = fieldData == null ? void 0 : fieldData.placeholder) != null ? _fieldData$placeholde : "";
      var inputTypeCoerced = ["textarea", "switch", "checkbox"].includes(type) ? type : ["in", "notIn"].includes(operator) ? "text" : inputType || "text";
      if (Array.isArray(valueAsArray)) {
        this.modelValue.from = valueAsArray[0];
        this.modelValue.to = valueAsArray[1];
      } else {
        this.modelValue.from = "";
        this.modelValue.to = "";
      }
      return {
        operator,
        value: value2,
        handleOnChange,
        title,
        className,
        type,
        inputType,
        values,
        listsAsArrays,
        parseNumbers,
        fieldData,
        disabled,
        separator,
        skipHook,
        testID,
        SelectorComponent,
        props,
        multiValueHandler,
        placeHolderText,
        inputTypeCoerced
      };
    },
    show: function show() {
      return !["null", "notNull"].includes(this.operator);
    }
  },
  methods: {
    change: function change(e) {
      var _e$target2;
      if (["textarea", "radio"].includes(this.type)) {
        var _e$target;
        return this.handleOnChange((e == null ? void 0 : (_e$target = e.target) == null ? void 0 : _e$target.value) || e);
      }
      return this.handleOnChange(parseNumber((e == null ? void 0 : (_e$target2 = e.target) == null ? void 0 : _e$target2.value) || e, {
        parseNumbers: this.parseNumbers
      }));
    },
    change1: function change1(i) {
      var _this2 = this;
      return function(e) {
        var _e$target3;
        return _this2.allProps.multiValueHandler((e == null ? void 0 : (_e$target3 = e.target) == null ? void 0 : _e$target3.value) || e, i);
      };
    }
  }
});
var render$5 = function render$52() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return !_vm.show ? _c("div", {
    staticClass: "hide"
  }) : ["text", "select"].includes(_vm.type) && ["between", "notBetween"].includes(_vm.operator) ? _c("span", {
    class: _vm.className + " rule-value-editor",
    attrs: {
      "data-testid": _vm.testID,
      "title": _vm.title
    }
  }, _vm._l(["from", "to"], function(key, i) {
    return _c("div", {
      key: i
    }, [_vm.type === "text" ? _c("custom-input", {
      attrs: {
        "type": _vm.allProps.inputTypeCoerced,
        "value": _vm.modelValue[key],
        "props": {
          key,
          placeholder: _vm.allProps.placeHolderText,
          class: _vm.standardClassnames.valueListItem,
          disabled: _vm.disabled
        },
        "events": {
          change: _vm.change1(i)
        }
      }
    }) : _c(_vm.allProps.SelectorComponent, _vm._b({
      key,
      tag: "component",
      class: _vm.standardClassnames.valueListItem,
      attrs: {
        "disabled": _vm.disabled
      }
    }, "component", _vm.otherProps, false)), i === 0 ? _c(_vm.separator, {
      tag: "component"
    }) : _vm._e()], 1);
  }), 0) : ["select", "multiselect"].includes(_vm.type) ? _c(_vm.allProps.SelectorComponent, _vm._b({
    tag: "component",
    attrs: {
      "testID": _vm.testID,
      "className": _vm.className,
      "title": _vm.title,
      "handleOnChange": _vm.handleOnChange,
      "disabled": _vm.disabled,
      "value": _vm.value,
      "options": _vm.values,
      "multiple": _vm.type === "multiselect",
      "listsAsArrays": _vm.listsAsArrays
    }
  }, "component", _vm.allProps.props, false)) : _vm.type === "radio" ? _c("span", {
    class: _vm.className + " rule-radio",
    attrs: {
      "data-testid": _vm.testID,
      "title": _vm.title
    }
  }, _vm._l(_vm.values, function(v, key) {
    return _c("custom-input", {
      key,
      attrs: {
        "type": _vm.type,
        "value": _vm.value,
        "props": {
          label: v.name,
          text: v.label,
          disabled: _vm.disabled
        },
        "events": {
          change: _vm.change
        }
      }
    });
  }), 1) : _c("span", {
    staticClass: "rule-value-editor"
  }, [_c("custom-input", {
    attrs: {
      "type": _vm.allProps.inputTypeCoerced,
      "value": _vm.type === "checkbox" ? !!_vm.value : _vm.value,
      "props": {
        "data-testid": _vm.testID,
        placeholder: _vm.allProps.placeHolderText,
        title: _vm.title,
        class: _vm.className,
        disabled: _vm.disabled
      },
      "events": {
        change: _vm.change
      }
    }
  })], 1);
};
var staticRenderFns$5 = [];
var __cssModules$5 = {};
var __component__$5 = /* @__PURE__ */ normalizeComponent(__vue2_script$5, render$5, staticRenderFns$5, false, __vue2_injectStyles$5, null, null, null);
function __vue2_injectStyles$5(context) {
  for (var o in __cssModules$5) {
    this[o] = __cssModules$5[o];
  }
}
var ValueEditor = /* @__PURE__ */ function() {
  return __component__$5.exports;
}();
var __vue2_script$4 = defineComponent({
  components: {
    TinySelect: Select
  },
  props: ["className", "handleOnChange", "options", "title", "value", "multiple", "listsAsArrays", "disabled", "testID"],
  setup: function setup10() {
    return {
      isOptionGroupArray
    };
  },
  computed: {
    valueSelector: function valueSelector2() {
      var handleOnChange = this.handleOnChange, value2 = this.value, multiple = this.multiple, listsAsArrays = this.listsAsArrays;
      return useValueSelector({
        handleOnChange,
        listsAsArrays,
        multiple,
        value: value2
      });
    },
    selectElementChangeHandler: function selectElementChangeHandler2() {
      var onChange = this.valueSelector.onChange;
      var multiple = this.multiple;
      return useSelectElementChangeHandler({
        multiple,
        onChange,
        field: "name"
      });
    },
    treeOp: function treeOp() {
      var data3 = this.formatField(this.options);
      return {
        nodeKey: "name",
        data: data3
      };
    }
  },
  methods: {
    formatField: function formatField(options) {
      var _this3 = this;
      if (options === void 0) {
        options = [];
      }
      options.map(function(option) {
        var children = option.children;
        if (children && children.length) {
          option.disabled = true;
          option.children = _this3.formatField(children);
        }
      });
      return options;
    },
    isSelected: function isSelected2(data3, value2) {
      return Array.isArray(data3) ? data3.includes(value2) : data3 === value2;
    }
  }
});
var render$4 = function render$42() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("tiny-select", {
    class: _vm.className + " query-builder-select",
    attrs: {
      "data-testid": _vm.testID,
      "value-field": "name",
      "text-field": "label",
      "render-type": "tree",
      "tree-op": _vm.treeOp,
      "title": _vm.title,
      "disabled": _vm.disabled,
      "multiple": !!_vm.multiple,
      "hover-expand": ""
    },
    on: {
      "change": _vm.selectElementChangeHandler
    },
    model: {
      value: _vm.valueSelector.val,
      callback: function callback($$v) {
        _vm.$set(_vm.valueSelector, "val", $$v);
      },
      expression: "valueSelector.val"
    }
  });
};
var staticRenderFns$4 = [];
var __cssModules$4 = {};
var __component__$4 = /* @__PURE__ */ normalizeComponent(__vue2_script$4, render$4, staticRenderFns$4, false, __vue2_injectStyles$4, null, null, null);
function __vue2_injectStyles$4(context) {
  for (var o in __cssModules$4) {
    this[o] = __cssModules$4[o];
  }
}
var FieldSelector = /* @__PURE__ */ function() {
  return __component__$4.exports;
}();
var __vue2_script$3 = defineComponent({
  name: "Combinator",
  components: {},
  props: ["className", "handleOnChange", "options", "title", "value", "multiple", "listsAsArrays", "disabled", "testID"],
  computed: {
    selectOption: function selectOption() {
      var _this4 = this;
      return this.options.filter(function(item) {
        return item.name === _this4.value;
      }).shift() || {};
    }
  },
  methods: {
    clickHandler: function clickHandler() {
      var _this5 = this;
      var value2 = this.options.filter(function(item) {
        return item.name !== _this5.value;
      }).map(function(item) {
        return item.name;
      }).shift();
      this.handleOnChange(value2);
    }
  }
});
var render$3 = function render$32() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "group-combinator-box"
  }, [_c("div", {
    staticClass: "combinator-branches"
  }), _c("div", {
    staticClass: "combinator-btn",
    class: {
      "is-disabled": _vm.disabled
    },
    on: {
      "click": _vm.clickHandler
    }
  }, [_vm._v(" " + _vm._s(_vm.selectOption.label) + " ")])]);
};
var staticRenderFns$3 = [];
var __cssModules$3 = {};
var __component__$3 = /* @__PURE__ */ normalizeComponent(__vue2_script$3, render$3, staticRenderFns$3, false, __vue2_injectStyles$3, null, null, null);
function __vue2_injectStyles$3(context) {
  for (var o in __cssModules$3) {
    this[o] = __cssModules$3[o];
  }
}
var Combinator = /* @__PURE__ */ function() {
  return __component__$3.exports;
}();
var __vue2_script$2 = defineComponent({
  props: {
    className: {
      type: String
    },
    label: {
      type: String
    },
    title: {
      type: String
    },
    testID: {
      type: String
    },
    dragRef: {
      type: Object
    }
  },
  setup: function setup11(props, context) {
    return _setup({
      props,
      context,
      renderless,
      api
    });
  }
});
var render$2 = function render$22() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("span", {
    ref: _vm.dragRef,
    class: _vm.className,
    attrs: {
      "data-testid": _vm.testID,
      "title": _vm.title
    }
  }, [_vm._v(_vm._s(_vm.label))]);
};
var staticRenderFns$2 = [];
var __cssModules$2 = {};
var __component__$2 = /* @__PURE__ */ normalizeComponent(__vue2_script$2, render$2, staticRenderFns$2, false, __vue2_injectStyles$2, null, null, null);
function __vue2_injectStyles$2(context) {
  for (var o in __cssModules$2) {
    this[o] = __cssModules$2[o];
  }
}
var DragHandle = /* @__PURE__ */ function() {
  return __component__$2.exports;
}();
var defaultControlElements = {
  addGroupAction: ActionElement,
  removeGroupAction: ActionElement,
  cloneGroupAction: ActionElement,
  cloneRuleAction: ActionElement,
  addRuleAction: ActionElement,
  clearDataAction: ActionElement,
  removeRuleAction: ActionElement,
  combinatorSelector: Combinator,
  inlineCombinator: InlineCombinator,
  operatorSelector: ValueSelector,
  fieldSelector: FieldSelector,
  valueEditor: ValueEditor,
  ruleGroup: RuleGroup,
  notToggle: NotToggle,
  lockRuleAction: ActionElement,
  rule: Rule,
  dragHandle: DragHandle,
  valueSourceSelector: ValueSelector,
  lockGroupAction: ActionElement
};
var mergeClassnames = function mergeClassnames2() {
  for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    args[_key2] = arguments[_key2];
  }
  var joinClassnamesByName = function joinClassnamesByName2(name) {
    return clsx(args.filter(Boolean).map(function(c) {
      return clsx(c[name]);
    }));
  };
  return {
    queryBuilder: joinClassnamesByName("queryBuilder"),
    ruleGroup: joinClassnamesByName("ruleGroup"),
    header: joinClassnamesByName("header"),
    body: joinClassnamesByName("body"),
    combinators: joinClassnamesByName("combinators"),
    addRule: joinClassnamesByName("addRule"),
    addGroup: joinClassnamesByName("addGroup"),
    cloneRule: joinClassnamesByName("cloneRule"),
    cloneGroup: joinClassnamesByName("cloneGroup"),
    removeGroup: joinClassnamesByName("removeGroup"),
    rule: joinClassnamesByName("rule"),
    fields: joinClassnamesByName("fields"),
    operators: joinClassnamesByName("operators"),
    value: joinClassnamesByName("value"),
    removeRule: joinClassnamesByName("removeRule"),
    clearData: joinClassnamesByName("clearData"),
    notToggle: joinClassnamesByName("notToggle"),
    dragHandle: joinClassnamesByName("dragHandle"),
    lockRule: joinClassnamesByName("lockRule"),
    lockGroup: joinClassnamesByName("lockGroup"),
    valueSource: joinClassnamesByName("valueSource")
  };
};
var objectKeys = function objectKeys2(obj) {
  return Object.keys(obj);
};
var preferPropDefaultTrue = function preferPropDefaultTrue2(prop, context) {
  return prop === false ? false : prop ? true : context === false ? false : true;
};
var preferPropDefaultFalse = function preferPropDefaultFalse2(prop, context) {
  return prop ? true : prop === false ? false : context ? true : false;
};
var preferProp = function preferProp2(def, prop, context) {
  return def ? preferPropDefaultTrue(prop, context) : preferPropDefaultFalse(prop, context);
};
var usePreferProp = function usePreferProp2(def, prop, context) {
  return useMemo(function() {
    return preferProp(def, prop, context);
  });
};
var useMergedContext = function useMergedContext2(props) {
  var rqbContext = useContext(QueryBuilderContext());
  var enableMountQueryChange = usePreferProp(true, props.enableMountQueryChange, rqbContext.enableMountQueryChange);
  var enableDragAndDrop = usePreferProp(false, props.enableDragAndDrop, rqbContext.enableDragAndDrop) && rqbContext.enableDragAndDrop !== false;
  var debugMode = usePreferProp(false, props.debugMode, rqbContext.debugMode);
  var controlClassnames = useMemo(function() {
    return mergeClassnames(defaultControlClassnames, rqbContext.controlClassnames, props.controlClassnames);
  }, [rqbContext.controlClassnames, props.controlClassnames]);
  var controlElements = useMemo(function() {
    return _extends({}, defaultControlElements, rqbContext.controlElements, props.controlElements);
  }, [props.controlElements, rqbContext.controlElements]);
  var translations = useMemo(function() {
    var translationsTemp = {};
    objectKeys(props.translations).forEach(function(t) {
      var contextTranslations = rqbContext.translations;
      translationsTemp[t] = _extends({}, defaultTranslations[t], contextTranslations, props.translations[t]);
    });
    return _extends({}, defaultTranslations, translationsTemp);
  }, [rqbContext.translations, props.translations]);
  var _controlClassnames = rqbContext.controlClassnames, _controlElements = rqbContext.controlElements, _debugMode = rqbContext.debugMode, _enableDragAndDrop = rqbContext.enableDragAndDrop, _enableMountQueryChange = rqbContext.enableMountQueryChange, _translations = rqbContext.translations, otherContext = _objectWithoutPropertiesLoose(rqbContext, _excluded2);
  return _extends({
    controlClassnames,
    controlElements,
    debugMode,
    enableDragAndDrop,
    enableMountQueryChange,
    translations
  }, otherContext);
};
var filterFieldsByComparator = function filterFieldsByComparator2(field, fields, operator) {
  if (!field.comparator) {
    var filterOutSameName = function filterOutSameName2(fd) {
      return fd.name !== field.name;
    };
    if (isOptionGroupArray(fields)) {
      return fields.map(function(ogs) {
        return _extends({}, ogs, {
          options: ogs.options.filter(filterOutSameName)
        });
      });
    }
    return fields.filter(filterOutSameName);
  }
  var filterByComparator = function filterByComparator2(fieldToCompare) {
    if (field.name === fieldToCompare.name) {
      return false;
    }
    if (typeof field.comparator === "string") {
      return field[field.comparator] === fieldToCompare[field.comparator];
    }
    return field.comparator(fieldToCompare, operator);
  };
  if (isOptionGroupArray(fields)) {
    return fields.map(function(ogs) {
      return _extends({}, ogs, {
        options: ogs.options.filter(filterByComparator)
      });
    }).filter(function(ogs) {
      return ogs.options.length > 0;
    });
  }
  return fields.filter(filterByComparator);
};
var parseNumber = function parseNumber2(v, _ref9) {
  var parseNumbers = _ref9.parseNumbers;
  if (typeof v === "bigint" || typeof v === "number") {
    return v;
  }
  return parseNumbers && (parseNumbers === "native" || numericRegex.test(v)) ? parseFloat(v) : v;
};
var findPath = function findPath2(path, query) {
  var level = 0;
  var target = query;
  while (target && level < path.length && "rules" in target) {
    var t = target.rules[path[level]];
    if (typeof t === "string") {
      target = null;
    } else {
      target = t;
    }
    level++;
  }
  return target;
};
var getParentPath = function getParentPath2(path) {
  return path.slice(0, path.length - 1);
};
var pathsAreEqual = function pathsAreEqual2(path1, path2) {
  return path1.every(function(val, idx) {
    return val === path2[idx];
  }) && path1.length === path2.length;
};
var getCommonAncestorPath = function getCommonAncestorPath2(path1, path2) {
  var parentPath1 = getParentPath(path1);
  var parentPath2 = getParentPath(path2);
  var commonAncestorPath = [];
  var i = 0;
  while (parentPath1[i] === parentPath2[i] && i < parentPath1.length && i < parentPath2.length) {
    commonAncestorPath.push(parentPath2[i]);
    i++;
  }
  return commonAncestorPath;
};
var pathIsDisabled = function pathIsDisabled2(path, query) {
  var level = 0;
  var disabled = !!query.disabled;
  var target = query;
  while ("rules" in target && level < path.length && !disabled) {
    var t = target.rules[path[level]];
    if (isPojo(t) && ("field" in t || "rules" in t)) {
      disabled = !!t.disabled;
      target = t;
    }
    level++;
  }
  return disabled;
};
var produce = function produce2(state, cb) {
  return cb(state) || state;
};
var prepareRule = function prepareRule2(rule, _temp3) {
  var _ref10 = _temp3 === void 0 ? {} : _temp3, _ref10$idGenerator = _ref10.idGenerator, idGenerator = _ref10$idGenerator === void 0 ? generateID : _ref10$idGenerator;
  return produce(rule, function(draft) {
    if (!draft.id) {
      draft.id = idGenerator();
    }
  });
};
var prepareRuleGroup = function prepareRuleGroup2(queryObject, _temp4) {
  var _ref11 = _temp4 === void 0 ? {} : _temp4, _ref11$idGenerator = _ref11.idGenerator, idGenerator = _ref11$idGenerator === void 0 ? generateID : _ref11$idGenerator;
  return produce(queryObject, function(draft) {
    if (!draft.id) {
      draft.id = idGenerator();
    }
    draft.rules = draft.rules.map(function(r3) {
      return typeof r3 === "string" ? r3 : "rules" in r3 ? prepareRuleGroup2(r3, {
        idGenerator
      }) : prepareRule(r3, {
        idGenerator
      });
    });
  });
};
var prepareRuleOrGroup = function prepareRuleOrGroup2(rg3, _temp5) {
  var _ref12 = _temp5 === void 0 ? {} : _temp5, _ref12$idGenerator = _ref12.idGenerator, idGenerator = _ref12$idGenerator === void 0 ? generateID : _ref12$idGenerator;
  return "rules" in rg3 ? prepareRuleGroup(rg3, {
    idGenerator
  }) : prepareRule(rg3, {
    idGenerator
  });
};
var regenerateID = function regenerateID2(rule, _temp6) {
  var _ref13 = _temp6 === void 0 ? {} : _temp6, _ref13$idGenerator = _ref13.idGenerator, idGenerator = _ref13$idGenerator === void 0 ? generateID : _ref13$idGenerator;
  return JSON.parse(JSON.stringify(_extends({}, rule, {
    id: idGenerator()
  })));
};
var regenerateIDs = function regenerateIDs2(ruleOrGroup, _temp7) {
  var _ref14 = _temp7 === void 0 ? {} : _temp7, _ref14$idGenerator = _ref14.idGenerator, idGenerator = _ref14$idGenerator === void 0 ? generateID : _ref14$idGenerator;
  if (!isPojo(ruleOrGroup))
    return ruleOrGroup;
  if (!("rules" in ruleOrGroup)) {
    return JSON.parse(JSON.stringify(_extends({}, ruleOrGroup, {
      id: idGenerator()
    })));
  }
  if ("combinator" in ruleOrGroup) {
    var rules2 = ruleOrGroup.rules.map(function(r3) {
      return isPojo(r3) && "rules" in r3 ? regenerateIDs2(r3, {
        idGenerator
      }) : regenerateID(r3, {
        idGenerator
      });
    });
    return _extends({}, ruleOrGroup, {
      id: idGenerator(),
      rules: rules2
    });
  }
  var rules = ruleOrGroup.rules.map(function(r3) {
    return typeof r3 === "string" ? r3 : isPojo(r3) && "rules" in r3 ? regenerateIDs2(r3, {
      idGenerator
    }) : regenerateID(r3, {
      idGenerator
    });
  });
  return _extends({}, ruleOrGroup, {
    id: idGenerator(),
    rules
  });
};
var add = function add2(query, ruleOrGroup, parentPath, _temp8) {
  var _ref15 = _temp8 === void 0 ? {} : _temp8, _ref15$combinators = _ref15.combinators, combinators = _ref15$combinators === void 0 ? defaultCombinators : _ref15$combinators, combinatorPreceding = _ref15.combinatorPreceding, _ref15$idGenerator = _ref15.idGenerator, idGenerator = _ref15$idGenerator === void 0 ? generateID : _ref15$idGenerator;
  return produce(query, function(draft) {
    var parent = findPath(parentPath, draft);
    if (!parent || !("rules" in parent))
      return;
    if (!("combinator" in parent) && parent.rules.length > 0) {
      var prevCombinator = parent.rules[parent.rules.length - 2];
      parent.rules.push(
        // @ts-expect-error This is technically a type violation until the next push
        // to the rules array, but that happens immediately and unconditionally so
        // there's no significant risk.
        combinatorPreceding != null ? combinatorPreceding : typeof prevCombinator === "string" ? prevCombinator : getFirstOption(combinators)
      );
    }
    parent.rules.push(prepareRuleOrGroup(ruleOrGroup, {
      idGenerator
    }));
  });
};
var update2 = function update3(query, prop, value2, path, _temp9) {
  var _ref16 = _temp9 === void 0 ? {} : _temp9, _ref16$resetOnFieldCh = _ref16.resetOnFieldChange, resetOnFieldChange = _ref16$resetOnFieldCh === void 0 ? true : _ref16$resetOnFieldCh, _ref16$resetOnOperato = _ref16.resetOnOperatorChange, resetOnOperatorChange = _ref16$resetOnOperato === void 0 ? false : _ref16$resetOnOperato, _ref16$getRuleDefault = _ref16.getRuleDefaultOperator, getRuleDefaultOperator = _ref16$getRuleDefault === void 0 ? function() {
    return "=";
  } : _ref16$getRuleDefault, _ref16$getValueSource = _ref16.getValueSources, getValueSources = _ref16$getValueSource === void 0 ? function() {
    return ["value"];
  } : _ref16$getValueSource, _ref16$getRuleDefault2 = _ref16.getRuleDefaultValue, getRuleDefaultValue = _ref16$getRuleDefault2 === void 0 ? function() {
    return "";
  } : _ref16$getRuleDefault2;
  return produce(query, function(draft) {
    if (prop === "combinator" && !("combinator" in draft)) {
      var parentRules = findPath(getParentPath(path), draft).rules;
      if (path[path.length - 1] % 2 === 1) {
        parentRules[path[path.length - 1]] = value2;
      }
      return;
    }
    var ruleOrGroup = findPath(path, draft);
    if (!ruleOrGroup)
      return;
    var isGroup = "rules" in ruleOrGroup;
    if (ruleOrGroup[prop] === value2)
      return;
    if (prop !== "valueSource") {
      if (isVue2 && !(prop in ruleOrGroup)) {
        appProperties().$set(ruleOrGroup, prop, value2);
      } else {
        ruleOrGroup[prop] = value2;
      }
    }
    if (isGroup)
      return;
    var resetValueSource = false;
    var resetValue = false;
    if (resetOnFieldChange && prop === "field") {
      ruleOrGroup.operator = getRuleDefaultOperator(value2);
      resetValueSource = true;
      resetValue = true;
    }
    if (resetOnOperatorChange && prop === "operator") {
      resetValue = true;
      resetValueSource = true;
    }
    var defaultValueSource = getValueSources(ruleOrGroup.field, ruleOrGroup.operator)[0];
    if (resetValueSource && ruleOrGroup.valueSource && defaultValueSource !== ruleOrGroup.valueSource || prop === "valueSource" && value2 !== ruleOrGroup.valueSource) {
      resetValue = !!ruleOrGroup.valueSource || !ruleOrGroup.valueSource && value2 !== defaultValueSource;
      ruleOrGroup.valueSource = resetValueSource ? defaultValueSource : value2;
    }
    if (resetValue) {
      ruleOrGroup.value = getRuleDefaultValue(ruleOrGroup);
    }
  });
};
var remove = function remove2(query, path) {
  if (
    // Can't remove the root group
    path.length === 0 || // Can't independently remove independent combinators
    !("combinator" in query) && !findPath(path, query)
  ) {
    return query;
  }
  return produce(query, function(draft) {
    var index = path[path.length - 1];
    var parent = findPath(getParentPath(path), draft);
    if (parent && "rules" in parent) {
      if (!("combinator" in parent) && parent.rules.length > 1) {
        var idxStartDelete = index === 0 ? 0 : index - 1;
        parent.rules.splice(idxStartDelete, 2);
      } else {
        parent.rules.splice(index, 1);
      }
    }
  });
};
var move = function move2(query, oldPath, newPath, _temp10) {
  var _ref17 = _temp10 === void 0 ? {} : _temp10, _ref17$clone = _ref17.clone, clone = _ref17$clone === void 0 ? false : _ref17$clone, _ref17$combinators = _ref17.combinators, combinators = _ref17$combinators === void 0 ? defaultCombinators : _ref17$combinators, _ref17$idGenerator = _ref17.idGenerator, idGenerator = _ref17$idGenerator === void 0 ? generateID : _ref17$idGenerator;
  if (pathsAreEqual(oldPath, newPath) || !findPath(getParentPath(newPath), query)) {
    return query;
  }
  var ruleOrGroupOriginal = findPath(oldPath, query);
  if (!ruleOrGroupOriginal) {
    return query;
  }
  var ruleOrGroup = clone ? "rules" in ruleOrGroupOriginal ? regenerateIDs(ruleOrGroupOriginal, {
    idGenerator
  }) : regenerateID(ruleOrGroupOriginal, {
    idGenerator
  }) : ruleOrGroupOriginal;
  return produce(query, function(draft) {
    var independentCombinators = !("combinator" in draft);
    var parentOfRuleToRemove = findPath(getParentPath(oldPath), draft);
    var ruleToRemoveIndex = oldPath[oldPath.length - 1];
    var oldPrevCombinator = ruleToRemoveIndex > 0 && independentCombinators ? parentOfRuleToRemove.rules[ruleToRemoveIndex - 1] : null;
    var oldNextCombinator = ruleToRemoveIndex < parentOfRuleToRemove.rules.length - 1 && independentCombinators ? parentOfRuleToRemove.rules[ruleToRemoveIndex + 1] : null;
    if (!clone) {
      var idxStartDelete = independentCombinators ? Math.max(0, ruleToRemoveIndex - 1) : ruleToRemoveIndex;
      var deleteLength = independentCombinators ? 2 : 1;
      parentOfRuleToRemove.rules.splice(idxStartDelete, deleteLength);
    }
    var newNewPath = [].concat(newPath);
    var commonAncestorPath = getCommonAncestorPath(oldPath, newPath);
    if (!clone && oldPath.length === commonAncestorPath.length + 1 && newPath[commonAncestorPath.length] > oldPath[commonAncestorPath.length]) {
      newNewPath[commonAncestorPath.length] -= independentCombinators ? 2 : 1;
    }
    var newNewParentPath = getParentPath(newNewPath);
    var parentToInsertInto = findPath(newNewParentPath, draft);
    var newIndex = newNewPath[newNewPath.length - 1];
    var insertRuleOrGroup = function insertRuleOrGroup2() {
      var _parentToInsertInto$r;
      for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        args[_key3] = arguments[_key3];
      }
      return (_parentToInsertInto$r = parentToInsertInto.rules).splice.apply(_parentToInsertInto$r, [newIndex, 0].concat(args));
    };
    if (parentToInsertInto.rules.length === 0 || !independentCombinators) {
      insertRuleOrGroup(ruleOrGroup);
    } else {
      if (newIndex === 0) {
        if (oldNextCombinator && ruleToRemoveIndex === 0) {
          insertRuleOrGroup(ruleOrGroup, oldNextCombinator);
        } else {
          var newNextCombinator = parentToInsertInto.rules[1] || getFirstOption(combinators) || oldPrevCombinator;
          insertRuleOrGroup(ruleOrGroup, newNextCombinator);
        }
      } else {
        if (oldPrevCombinator) {
          insertRuleOrGroup(oldPrevCombinator, ruleOrGroup);
        } else {
          var newPrevCombinator = parentToInsertInto.rules[newIndex - 2] || getFirstOption(combinators) || oldNextCombinator;
          insertRuleOrGroup(newPrevCombinator, ruleOrGroup);
        }
      }
    }
  });
};
var noop = function noop2() {
};
var useQueryBuilder = function useQueryBuilder2(props, context) {
  var defaultQuery = props.defaultQuery, queryProp = props.query, fieldsPropOriginal = props.fields, _props$operators = props.operators, operators = _props$operators === void 0 ? defaultOperators : _props$operators, _props$combinators = props.combinators, combinators = _props$combinators === void 0 ? defaultCombinators : _props$combinators, _props$translations = props.translations, translationsProp = _props$translations === void 0 ? defaultTranslations : _props$translations, _props$enableMountQue = props.enableMountQueryChange, enableMountQueryChangeProp = _props$enableMountQue === void 0 ? true : _props$enableMountQue, controlClassnamesProp = props.controlClassnames, controlElementsProp = props.controlElements, getDefaultField = props.getDefaultField, getDefaultOperator = props.getDefaultOperator, getDefaultValue = props.getDefaultValue, getOperators = props.getOperators, getValueEditorType = props.getValueEditorType, _props$getValueEditor = props.getValueEditorSeparator, getValueEditorSeparator = _props$getValueEditor === void 0 ? function() {
    return null;
  } : _props$getValueEditor, getValueSources = props.getValueSources, getInputType = props.getInputType, getValues = props.getValues, _props$getRuleClassna = props.getRuleClassname, getRuleClassname = _props$getRuleClassna === void 0 ? function() {
    return "";
  } : _props$getRuleClassna, _props$getRuleGroupCl = props.getRuleGroupClassname, getRuleGroupClassname = _props$getRuleGroupCl === void 0 ? function() {
    return "";
  } : _props$getRuleGroupCl, _props$onAddRule = props.onAddRule, onAddRule = _props$onAddRule === void 0 ? function(r3) {
    return r3;
  } : _props$onAddRule, _props$onAddGroup = props.onAddGroup, onAddGroup = _props$onAddGroup === void 0 ? function(rg3) {
    return rg3;
  } : _props$onAddGroup, _props$onRemove = props.onRemove, onRemove = _props$onRemove === void 0 ? function() {
    return true;
  } : _props$onRemove, _props$onQueryChange = props.onQueryChange, onQueryChange = _props$onQueryChange === void 0 ? noop : _props$onQueryChange, _props$showCombinator = props.showCombinatorsBetweenRules, showCombinatorsBetweenRules = _props$showCombinator === void 0 ? false : _props$showCombinator, _props$showNotToggle = props.showNotToggle, showNotToggle = _props$showNotToggle === void 0 ? false : _props$showNotToggle, _props$showCloneButto = props.showCloneButtons, showCloneButtons = _props$showCloneButto === void 0 ? false : _props$showCloneButto, _props$showLockButton = props.showLockButtons, showLockButtons = _props$showLockButton === void 0 ? false : _props$showLockButton, _props$showBranches = props.showBranches, showBranches = _props$showBranches === void 0 ? true : _props$showBranches, _props$resetOnFieldCh = props.resetOnFieldChange, resetOnFieldChange = _props$resetOnFieldCh === void 0 ? true : _props$resetOnFieldCh, _props$resetOnOperato = props.resetOnOperatorChange, resetOnOperatorChange = _props$resetOnOperato === void 0 ? false : _props$resetOnOperato, _props$autoSelectFiel = props.autoSelectField, autoSelectField = _props$autoSelectFiel === void 0 ? true : _props$autoSelectFiel, _props$autoSelectOper = props.autoSelectOperator, autoSelectOperator = _props$autoSelectOper === void 0 ? true : _props$autoSelectOper, _props$addRuleToNewGr = props.addRuleToNewGroups, addRuleToNewGroups = _props$addRuleToNewGr === void 0 ? true : _props$addRuleToNewGr, enableDragAndDropProp = props.enableDragAndDrop, independentCombinators = props.independentCombinators, _props$listsAsArrays = props.listsAsArrays, listsAsArrays = _props$listsAsArrays === void 0 ? false : _props$listsAsArrays, _props$parseNumbers = props.parseNumbers, parseNumbers = _props$parseNumbers === void 0 ? false : _props$parseNumbers, _props$disabled = props.disabled, disabled = _props$disabled === void 0 ? false : _props$disabled, _props$displayOnlyFie = props.displayOnlyField, displayOnlyField = _props$displayOnlyFie === void 0 ? false : _props$displayOnlyFie, validator = props.validator, _props$debugMode = props.debugMode, debugModeProp = _props$debugMode === void 0 ? false : _props$debugMode, _props$onLog = props.onLog, onLog = _props$onLog === void 0 ? console.log : _props$onLog, _props$idGenerator = props.idGenerator, idGenerator = _props$idGenerator === void 0 ? generateID : _props$idGenerator;
  var rqbContext = useMergedContext({
    controlClassnames: controlClassnamesProp,
    controlElements: controlElementsProp,
    debugMode: debugModeProp,
    enableDragAndDrop: enableDragAndDropProp,
    enableMountQueryChange: enableMountQueryChangeProp,
    translations: translationsProp
  });
  var controlClassnames = rqbContext.controlClassnames, controlElements = rqbContext.controlElements, debugMode = rqbContext.debugMode, enableDragAndDrop = rqbContext.enableDragAndDrop, enableMountQueryChange = rqbContext.enableMountQueryChange, translations = rqbContext.translations;
  var defaultField = useMemo(function() {
    return {
      id: translations.fields.placeholderName,
      name: translations.fields.placeholderName,
      label: translations.fields.placeholderLabel
    };
  }, [translations.fields.placeholderLabel, translations.fields.placeholderName]);
  var fieldsProp = useMemo(function() {
    return fieldsPropOriginal != null ? fieldsPropOriginal : [defaultField];
  });
  var fields = useMemo(function() {
    var f = Array.isArray(fieldsProp) ? fieldsProp : objectKeys(fieldsProp).map(function(fld) {
      return _extends({}, fieldsProp[fld], {
        name: fld
      });
    }).sort(function(a, b) {
      return a.label.localeCompare(b.label);
    });
    if (isOptionGroupArray(f)) {
      if (autoSelectField) {
        return uniqOptGroups(f);
      } else {
        return uniqOptGroups([{
          label: translations.fields.placeholderGroupLabel,
          options: [defaultField]
        }].concat(f));
      }
    } else {
      if (autoSelectField) {
        return uniqByName(f);
      } else {
        return uniqByName([defaultField].concat(f));
      }
    }
  }, [autoSelectField, defaultField, fieldsProp, translations.fields.placeholderGroupLabel]);
  var fieldMap = useMemo(function() {
    if (!Array.isArray(fieldsProp)) {
      var fp = {};
      objectKeys(fieldsProp).forEach(function(f) {
        return fp[f] = _extends({}, fieldsProp[f], {
          name: f
        });
      });
      if (autoSelectField) {
        return fp;
      } else {
        var _extends2;
        return _extends({}, fp, (_extends2 = {}, _extends2[translations.fields.placeholderName] = defaultField, _extends2));
      }
    }
    var fm = {};
    if (isOptionGroupArray(fields)) {
      fields.forEach(function(f) {
        return f.options.forEach(function(opt) {
          return fm[opt.name] = opt;
        });
      });
    } else {
      fields.forEach(function(f) {
        return fm[f.name] = f;
      });
    }
    return fm;
  }, [autoSelectField, defaultField, fields, fieldsProp, translations.fields.placeholderName]);
  var defaultOperator = useMemo(function() {
    return {
      id: translations.operators.placeholderName,
      name: translations.operators.placeholderName,
      label: translations.operators.placeholderLabel
    };
  }, [translations.operators.placeholderLabel, translations.operators.placeholderName]);
  var getOperatorsMain = useCallback(function(field) {
    var fieldData = fieldMap[field];
    var opsFinal = operators;
    if (fieldData != null && fieldData.operators) {
      opsFinal = fieldData.operators;
    } else if (getOperators) {
      var ops = getOperators(field);
      if (ops) {
        opsFinal = ops;
      }
    }
    if (!autoSelectOperator) {
      if (isOptionGroupArray(opsFinal)) {
        opsFinal = [{
          label: translations.operators.placeholderGroupLabel,
          options: [defaultOperator]
        }].concat(opsFinal);
      } else {
        opsFinal = [defaultOperator].concat(opsFinal);
      }
    }
    return isOptionGroupArray(opsFinal) ? uniqOptGroups(opsFinal) : uniqByName(opsFinal);
  }, [autoSelectOperator, defaultOperator, fieldMap, getOperators, operators, translations.operators.placeholderGroupLabel]);
  var getRuleDefaultOperator = useCallback(function(field) {
    var _getOperatorsMain, _getFirstOption;
    var fieldData = fieldMap[field];
    if (fieldData != null && fieldData.defaultOperator) {
      return fieldData.defaultOperator;
    }
    if (getDefaultOperator) {
      if (typeof getDefaultOperator === "function") {
        return getDefaultOperator(field);
      } else {
        return getDefaultOperator;
      }
    }
    var ops = (_getOperatorsMain = getOperatorsMain(field)) != null ? _getOperatorsMain : (
      /* istanbul ignore next */
      []
    );
    return ops.length ? (_getFirstOption = getFirstOption(ops)) != null ? _getFirstOption : (
      /* istanbul ignore next */
      ""
    ) : (
      /* istanbul ignore next */
      ""
    );
  });
  var getValueEditorTypeMain = useCallback(function(field, operator) {
    if (getValueEditorType) {
      var vet = getValueEditorType(field, operator);
      if (vet)
        return vet;
    }
    return "text";
  });
  var getValueSourcesMain = useCallback(function(field, operator) {
    return getValueSourcesUtil(fieldMap[field], operator, getValueSources);
  });
  var getValuesMain = useCallback(function(field, operator) {
    var fieldData = fieldMap[field];
    if (fieldData != null && fieldData.values) {
      return fieldData.values;
    }
    if (getValues) {
      var vals = getValues(field, operator);
      if (vals)
        return vals;
    }
    return [];
  });
  var getRuleDefaultValue = useCallback(function(rule) {
    var fieldData = fieldMap[rule.field];
    if ((fieldData == null ? void 0 : fieldData.defaultValue) !== void 0 && fieldData.defaultValue !== null) {
      return fieldData.defaultValue;
    } else if (getDefaultValue) {
      return getDefaultValue(rule);
    }
    var value2 = "";
    var values = getValuesMain(rule.field, rule.operator);
    var getFirstOptionsFrom = function getFirstOptionsFrom2(opts) {
      var firstOption = getFirstOption(opts);
      if (rule.operator === "between" || rule.operator === "notBetween") {
        var valueAsArray = [firstOption, firstOption];
        return listsAsArrays ? valueAsArray : joinWith(valueAsArray.map(function(v) {
          return v != null ? v : (
            /* istanbul ignore next */
            ""
          );
        }), ",");
      } else {
        return firstOption;
      }
    };
    if (rule.valueSource === "field") {
      var filteredFields = filterFieldsByComparator(fieldData, fields, rule.operator);
      if (filteredFields.length > 0) {
        value2 = getFirstOptionsFrom(filteredFields);
      } else {
        value2 = "";
      }
    } else if (values.length) {
      value2 = getFirstOptionsFrom(values);
    } else {
      var editorType = getValueEditorTypeMain(rule.field, rule.operator);
      if (editorType === "checkbox") {
        value2 = false;
      }
    }
    return value2;
  });
  var getInputTypeMain = useCallback(function(field, operator) {
    if (getInputType) {
      var inputType = getInputType(field, operator);
      if (inputType)
        return inputType;
    }
    return "text";
  });
  var createRule = useCallback(function() {
    var _getValueSourcesMain$;
    var field = "";
    if ((fields == null ? void 0 : fields.length) > 0 && fields[0]) {
      var _getFirstOption2;
      field = (_getFirstOption2 = getFirstOption(fields)) != null ? _getFirstOption2 : (
        /* istanbul ignore next */
        ""
      );
    }
    if (getDefaultField) {
      if (typeof getDefaultField === "function") {
        field = getDefaultField(fields);
      } else {
        field = getDefaultField;
      }
    }
    var operator = getRuleDefaultOperator(field);
    var valueSource = (_getValueSourcesMain$ = getValueSourcesMain(field, operator)[0]) != null ? _getValueSourcesMain$ : "value";
    var newRule = {
      id: idGenerator(),
      field,
      operator,
      valueSource,
      value: ""
    };
    var value2 = getRuleDefaultValue(newRule);
    return _extends({}, newRule, {
      value: value2
    });
  });
  var createRuleGroup = useCallback(function() {
    var _getFirstOption3;
    if (independentCombinators) {
      return {
        id: idGenerator(),
        rules: addRuleToNewGroups ? [createRule()] : [],
        not: false
      };
    }
    return {
      id: idGenerator(),
      rules: addRuleToNewGroups ? [createRule()] : [],
      combinator: (_getFirstOption3 = getFirstOption(combinators)) != null ? _getFirstOption3 : (
        /* istanbul ignore next */
        ""
      ),
      not: false
    };
  });
  var isFirstRender = useRef(true, context);
  var _useState = useState(defaultQuery ? prepareRuleGroup(defaultQuery, {
    idGenerator
  }) : createRuleGroup()), queryState = _useState[0], setQueryState = _useState[1];
  var query = queryProp ? isFirstRender.current ? prepareRuleGroup(queryProp, {
    idGenerator
  }) : queryProp : queryState;
  useControlledOrUncontrolled({
    defaultQuery,
    queryProp,
    isFirstRender: isFirstRender.current
  });
  isFirstRender.current = false;
  useEffect(function() {
    if (enableMountQueryChange) {
      onQueryChange(query);
    }
  }, []);
  var uncontrolled = !queryProp;
  var dispatch = useCallback(function(newQuery) {
    if (uncontrolled) {
      setQueryState(newQuery);
    }
    onQueryChange(newQuery);
  });
  var queryDisabled = useMemo(function() {
    return disabled === true || Array.isArray(disabled) && disabled.some(function(p) {
      return p.length === 0;
    });
  });
  var disabledPaths = useMemo(function() {
    return Array.isArray(disabled) && disabled || [];
  });
  var onRuleAdd = function onRuleAdd2(rule, parentPath, context2) {
    var _newRule$combinatorPr;
    if (pathIsDisabled(parentPath, query) || queryDisabled) {
      if (debugMode) {
        onLog({
          type: LogType.parentPathDisabled,
          rule,
          parentPath,
          query
        });
      }
      return;
    }
    var newRule = onAddRule(rule, parentPath, query, context2);
    if (!newRule) {
      if (debugMode) {
        onLog({
          type: LogType.onAddRuleFalse,
          rule,
          parentPath,
          query
        });
      }
      return;
    }
    var newQuery = add(query, newRule, parentPath, {
      combinators,
      combinatorPreceding: (_newRule$combinatorPr = newRule.combinatorPreceding) != null ? _newRule$combinatorPr : void 0
    });
    if (debugMode) {
      onLog({
        type: LogType.add,
        query,
        newQuery,
        newRule,
        parentPath
      });
    }
    dispatch(newQuery);
  };
  var onGroupAdd = function onGroupAdd2(ruleGroup2, parentPath, context2) {
    var _newGroup$combinatorP;
    if (pathIsDisabled(parentPath, query) || queryDisabled) {
      if (debugMode) {
        onLog({
          type: LogType.parentPathDisabled,
          ruleGroup: ruleGroup2,
          parentPath,
          query
        });
      }
      return;
    }
    var newGroup = onAddGroup(ruleGroup2, parentPath, query, context2);
    if (!newGroup) {
      if (debugMode) {
        onLog({
          type: LogType.onAddGroupFalse,
          ruleGroup: ruleGroup2,
          parentPath,
          query
        });
      }
      return;
    }
    var newQuery = add(query, newGroup, parentPath, {
      combinators,
      combinatorPreceding: (_newGroup$combinatorP = newGroup.combinatorPreceding) != null ? _newGroup$combinatorP : void 0
    });
    if (debugMode) {
      onLog({
        type: LogType.add,
        query,
        newQuery,
        newGroup,
        parentPath
      });
    }
    dispatch(newQuery);
  };
  var onPropChange = function onPropChange2(prop, value2, path) {
    if (pathIsDisabled(path, query) && prop !== "disabled" || queryDisabled) {
      if (debugMode) {
        onLog({
          type: LogType.pathDisabled,
          path,
          prop,
          value: value2,
          query
        });
      }
      return;
    }
    var newQuery = update2(query, prop, value2, path, {
      resetOnFieldChange,
      resetOnOperatorChange,
      getRuleDefaultOperator,
      getValueSources: getValueSourcesMain,
      getRuleDefaultValue
    });
    if (debugMode) {
      onLog({
        type: LogType.update,
        query,
        newQuery,
        prop,
        value: value2,
        path
      });
    }
    dispatch(newQuery);
  };
  var onRuleOrGroupRemove = function onRuleOrGroupRemove2(path, context2) {
    if (pathIsDisabled(path, query) || queryDisabled) {
      if (debugMode) {
        onLog({
          type: LogType.pathDisabled,
          path,
          query
        });
      }
      return;
    }
    var ruleOrGroup = findPath(path, query);
    if (ruleOrGroup) {
      if (onRemove(ruleOrGroup, path, query, context2)) {
        var newQuery = remove(query, path);
        if (debugMode) {
          onLog({
            type: LogType.remove,
            query,
            newQuery,
            path,
            ruleOrGroup
          });
        }
        dispatch(newQuery);
      } else {
        if (debugMode) {
          onLog({
            type: LogType.onRemoveFalse,
            ruleOrGroup,
            path,
            query
          });
        }
      }
    }
  };
  var moveRule = function moveRule2(oldPath, newPath, clone) {
    if (pathIsDisabled(oldPath, query) || queryDisabled) {
      if (debugMode) {
        onLog({
          type: LogType.pathDisabled,
          oldPath,
          newPath,
          query
        });
      }
      return;
    }
    var newQuery = move(query, oldPath, newPath, {
      clone,
      combinators
    });
    if (debugMode) {
      onLog({
        type: LogType.move,
        query,
        newQuery,
        oldPath,
        newPath,
        clone
      });
    }
    dispatch(newQuery);
  };
  var _useMemo = useMemo(function() {
    var validationResult2 = typeof validator === "function" ? validator(query) : {};
    var validationMap2 = typeof validationResult2 === "object" ? validationResult2 : {};
    return {
      validationResult: validationResult2,
      validationMap: validationMap2
    };
  }), validationResult = _useMemo.validationResult, validationMap = _useMemo.validationMap;
  var schema = useMemo(function() {
    return {
      fields,
      fieldMap,
      combinators,
      classNames: controlClassnames,
      createRule,
      createRuleGroup,
      controls: controlElements,
      getOperators: getOperatorsMain,
      getValueEditorType: getValueEditorTypeMain,
      getValueSources: getValueSourcesMain,
      getInputType: getInputTypeMain,
      getValues: getValuesMain,
      getValueEditorSeparator,
      getRuleClassname,
      getRuleGroupClassname,
      showCombinatorsBetweenRules,
      showNotToggle,
      showCloneButtons,
      showLockButtons,
      autoSelectField,
      autoSelectOperator,
      addRuleToNewGroups,
      enableDragAndDrop,
      independentCombinators: !!independentCombinators,
      listsAsArrays,
      parseNumbers,
      validationMap,
      disabledPaths
    };
  });
  var actions = {
    onRuleAdd,
    onGroupAdd,
    onRuleRemove: onRuleOrGroupRemove,
    onGroupRemove: onRuleOrGroupRemove,
    onPropChange,
    moveRule
  };
  var wrapperClassName = useMemo(function() {
    var _clsx;
    return clsx(standardClassnames.queryBuilder, clsx(controlClassnames.queryBuilder), (_clsx = {}, _clsx[standardClassnames.branches] = showBranches, _clsx[standardClassnames.disabled] = query.disabled || queryDisabled, _clsx[standardClassnames.displayOnlyField] = displayOnlyField, _clsx[standardClassnames.valid] = typeof validationResult === "boolean" && validationResult, _clsx[standardClassnames.invalid] = typeof validationResult === "boolean" && !validationResult, _clsx));
  }, [controlClassnames.queryBuilder, queryDisabled, query.disabled, validationResult]);
  return {
    actions,
    query,
    queryDisabled,
    rqbContext,
    schema,
    translations,
    wrapperClassName
  };
};
var useRule = function useRule2(props) {
  var _fieldMap$field, _fieldData$inputType, _fieldData$valueSourc, _ref18, _fieldData$values, _validationMap, _clsx2;
  var id = props.id, path = props.path, ruleProp = props.rule, schema = props.schema, actions = props.actions, disabledProp = props.disabled, parentDisabled = props.parentDisabled, fieldProp = props.field, operatorProp = props.operator, valueProp = props.value, valueSourceProp = props.valueSource, _props$dragMonitorId = props.dragMonitorId, dragMonitorId = _props$dragMonitorId === void 0 ? "" : _props$dragMonitorId, _props$dropMonitorId = props.dropMonitorId, dropMonitorId = _props$dropMonitorId === void 0 ? "" : _props$dropMonitorId, _props$dndRef = props.dndRef, dndRef = _props$dndRef === void 0 ? null : _props$dndRef, _props$dragRef = props.dragRef, dragRef = _props$dragRef === void 0 ? null : _props$dragRef, _props$isDragging = props.isDragging, isDragging = _props$isDragging === void 0 ? false : _props$isDragging, _props$isOver = props.isOver, isOver = _props$isOver === void 0 ? false : _props$isOver, onlyOne2 = props.onlyOne;
  var classNamesProp = schema.classNames, fields = schema.fields, fieldMap = schema.fieldMap, getInputType = schema.getInputType, getOperators = schema.getOperators, getValueEditorType = schema.getValueEditorType, getValueEditorSeparator = schema.getValueEditorSeparator, getValueSources = schema.getValueSources, getValues = schema.getValues, validationMap = schema.validationMap, getRuleClassname = schema.getRuleClassname;
  var moveRule = actions.moveRule, onPropChange = actions.onPropChange, onRuleRemove = actions.onRuleRemove;
  var disabled = !!parentDisabled || !!disabledProp;
  var rule = ruleProp ? ruleProp : {
    field: fieldProp,
    operator: operatorProp,
    value: valueProp,
    valueSource: valueSourceProp
  };
  var field = rule.field, operator = rule.operator, value2 = rule.value, valueSource = rule.valueSource;
  useDeprecatedProps("rule", !!ruleProp);
  var classNames = useMemo(function() {
    return {
      dragHandle: clsx(standardClassnames.dragHandle, classNamesProp.dragHandle),
      fields: clsx(standardClassnames.fields, classNamesProp.fields),
      operators: clsx(standardClassnames.operators, classNamesProp.operators),
      valueSource: clsx(standardClassnames.valueSource, classNamesProp.valueSource),
      value: clsx(standardClassnames.value, classNamesProp.value),
      cloneRule: clsx(standardClassnames.cloneRule, classNamesProp.cloneRule),
      lockRule: clsx(standardClassnames.lockRule, classNamesProp.lockRule),
      removeRule: clsx(standardClassnames.removeRule, classNamesProp.removeRule),
      clearData: clsx(standardClassnames.clearData, classNamesProp.clearData)
    };
  }, [classNamesProp.dragHandle, classNamesProp.fields, classNamesProp.operators, classNamesProp.valueSource, classNamesProp.value, classNamesProp.cloneRule, classNamesProp.lockRule, classNamesProp.removeRule, classNamesProp.clearData]);
  var generateOnChangeHandler = function generateOnChangeHandler2(prop) {
    return function(value22) {
      if (!disabled) {
        onPropChange(prop, value22, path);
      }
    };
  };
  var cloneRule = function cloneRule2(_event) {
    if (!disabled) {
      var newPath = [].concat(getParentPath(path), [path[path.length - 1] + 1]);
      moveRule(path, newPath, true);
    }
  };
  var toggleLockRule = function toggleLockRule2(_event) {
    onPropChange("disabled", !disabled, path);
  };
  var removeRule = function removeRule2(_event) {
    if (!disabled) {
      onRuleRemove(onlyOne2 ? path.slice(0, -1) : path);
    }
  };
  var clearData = function clearData2(_event) {
    onPropChange("value", "", path);
    onPropChange("field", "", path);
  };
  var fieldData = (_fieldMap$field = fieldMap == null ? void 0 : fieldMap[field]) != null ? _fieldMap$field : {
    name: field,
    label: field
  };
  var inputType = (_fieldData$inputType = fieldData.inputType) != null ? _fieldData$inputType : getInputType(field, operator);
  var operators = getOperators(field);
  var operatorObject = getOption(operators, operator);
  var arity = operatorObject == null ? void 0 : operatorObject.arity;
  var hideValueControls = typeof arity === "string" && arity === "unary" || typeof arity === "number" && arity < 2;
  var valueSources = typeof fieldData.valueSources === "function" ? fieldData.valueSources(operator) : (_fieldData$valueSourc = fieldData.valueSources) != null ? _fieldData$valueSourc : getValueSources(field, operator);
  var valueEditorType = valueSource === "field" ? "select" : (_ref18 = typeof fieldData.valueEditorType === "function" ? fieldData.valueEditorType(operator) : fieldData.valueEditorType) != null ? _ref18 : getValueEditorType(field, operator);
  var valueEditorSeparator = getValueEditorSeparator(field, operator);
  var values = valueSource === "field" ? filterFieldsByComparator(fieldData, fields, operator) : (_fieldData$values = fieldData.values) != null ? _fieldData$values : getValues(field, operator);
  var valueSourceOptions = valueSources.map(function(vs) {
    return {
      name: vs,
      label: vs
    };
  });
  var validationResult = (_validationMap = validationMap[id != null ? id : (
    /* istanbul ignore next */
    ""
  )]) != null ? _validationMap : typeof fieldData.validator === "function" ? fieldData.validator({
    id,
    field,
    operator,
    value: value2
  }) : null;
  var validationClassName = getValidationClassNames(validationResult);
  var fieldBasedClassName = useMemo(function() {
    var _fieldData$className;
    return (_fieldData$className = fieldData == null ? void 0 : fieldData.className) != null ? _fieldData$className : "";
  }, [fieldData == null ? void 0 : fieldData.className]);
  var operatorBasedClassName = useMemo(function() {
    var _operatorObject$class;
    return (_operatorObject$class = operatorObject == null ? void 0 : operatorObject.className) != null ? _operatorObject$class : "";
  }, [operatorObject == null ? void 0 : operatorObject.className]);
  var outerClassName = clsx(getRuleClassname(rule), fieldBasedClassName, operatorBasedClassName, standardClassnames.rule, classNamesProp.rule, (_clsx2 = {}, _clsx2[standardClassnames.disabled] = disabled, _clsx2[standardClassnames.dndDragging] = isDragging, _clsx2[standardClassnames.dndOver] = isOver, _clsx2), validationClassName);
  return {
    classNames,
    cloneRule,
    disabled,
    dndRef,
    dragMonitorId,
    dragRef,
    dropMonitorId,
    fieldData,
    generateOnChangeHandler,
    hideValueControls,
    inputType,
    operators,
    outerClassName,
    removeRule,
    clearData,
    rule,
    toggleLockRule,
    validationResult,
    valueEditorSeparator,
    valueEditorType,
    values,
    valueSourceOptions,
    valueSources
  };
};
var useRuleGroup = function useRuleGroup2(props) {
  var _clsx4;
  var id = props.id, path = props.path, ruleGroupProp = props.ruleGroup, schema = props.schema, actions = props.actions, disabledProp = props.disabled, parentDisabled = props.parentDisabled, combinatorProp = props.combinator, rulesProp = props.rules, notProp = props.not, _props$dragMonitorId2 = props.dragMonitorId, dragMonitorId = _props$dragMonitorId2 === void 0 ? "" : _props$dragMonitorId2, _props$dropMonitorId2 = props.dropMonitorId, dropMonitorId = _props$dropMonitorId2 === void 0 ? "" : _props$dropMonitorId2, _props$previewRef = props.previewRef, previewRef = _props$previewRef === void 0 ? null : _props$previewRef, _props$dragRef2 = props.dragRef, dragRef = _props$dragRef2 === void 0 ? null : _props$dragRef2, _props$dropRef = props.dropRef, dropRef = _props$dropRef === void 0 ? null : _props$dropRef, _props$isDragging2 = props.isDragging, isDragging = _props$isDragging2 === void 0 ? false : _props$isDragging2, _props$isOver2 = props.isOver, isOver = _props$isOver2 === void 0 ? false : _props$isOver2;
  var classNamesProp = schema.classNames, combinators = schema.combinators, createRule = schema.createRule, createRuleGroup = schema.createRuleGroup, independentCombinators = schema.independentCombinators, validationMap = schema.validationMap, enableDragAndDrop = schema.enableDragAndDrop, _schema$getRuleGroupC = schema.getRuleGroupClassname, getRuleGroupClassname = _schema$getRuleGroupC === void 0 ? function() {
    return "";
  } : _schema$getRuleGroupC;
  var onGroupAdd = actions.onGroupAdd, onGroupRemove = actions.onGroupRemove, onPropChange = actions.onPropChange, onRuleAdd = actions.onRuleAdd, moveRule = actions.moveRule;
  var disabled = !!parentDisabled || !!disabledProp;
  var ruleGroup2 = ruleGroupProp ? _extends({}, ruleGroupProp) : {
    rules: rulesProp,
    not: notProp
  };
  var firstCombinator = getFirstOption(combinators);
  var combinator = ruleGroupProp && "combinator" in ruleGroupProp ? ruleGroupProp.combinator : !ruleGroupProp ? combinatorProp != null ? combinatorProp : firstCombinator : firstCombinator;
  if (!independentCombinators) {
    ruleGroup2.combinator = combinator;
  }
  useDeprecatedProps("ruleGroup", !!ruleGroupProp);
  var classNames = useMemo(function() {
    var _clsx3;
    return {
      header: clsx(standardClassnames.header, classNamesProp.header, (_clsx3 = {}, _clsx3[standardClassnames.dndOver] = isOver, _clsx3)),
      dragHandle: clsx(standardClassnames.dragHandle, classNamesProp.dragHandle),
      combinators: clsx(standardClassnames.combinators, classNamesProp.combinators),
      notToggle: clsx(standardClassnames.notToggle, classNamesProp.notToggle),
      addRule: clsx(standardClassnames.addRule, classNamesProp.addRule),
      addGroup: clsx(standardClassnames.addGroup, classNamesProp.addGroup),
      cloneGroup: clsx(standardClassnames.cloneGroup, classNamesProp.cloneGroup),
      lockGroup: clsx(standardClassnames.lockGroup, classNamesProp.lockGroup),
      removeGroup: clsx(standardClassnames.removeGroup, classNamesProp.removeGroup),
      body: clsx(standardClassnames.body, classNamesProp.body)
    };
  }, [classNamesProp.addGroup, classNamesProp.addRule, classNamesProp.body, classNamesProp.cloneGroup, classNamesProp.combinators, classNamesProp.dragHandle, classNamesProp.header, classNamesProp.lockGroup, classNamesProp.notToggle, classNamesProp.removeGroup, isOver]);
  var onCombinatorChange = function onCombinatorChange2(value2) {
    if (!disabled) {
      onPropChange("combinator", value2, path);
    }
  };
  var onIndependentCombinatorChange = function onIndependentCombinatorChange2(value2, index) {
    if (!disabled) {
      onPropChange("combinator", value2, path.concat([index]));
    }
  };
  var onNotToggleChange = function onNotToggleChange2(checked2) {
    if (!disabled) {
      onPropChange("not", checked2, path);
    }
  };
  var addRule = function addRule2(_event, context) {
    if (!disabled) {
      var newRule = createRule();
      onRuleAdd(newRule, path, context);
    }
  };
  var addGroup = function addGroup2(_event, context) {
    if (!disabled) {
      var newGroup = createRuleGroup();
      onGroupAdd(newGroup, path, context);
    }
  };
  var cloneGroup = function cloneGroup2(_event) {
    if (!disabled) {
      var newPath = [].concat(getParentPath(path), [path[path.length - 1] + 1]);
      moveRule(path, newPath, true);
    }
  };
  var toggleLockGroup = function toggleLockGroup2(_event) {
    onPropChange("disabled", !disabled, path);
  };
  var removeGroup = function removeGroup2(_event) {
    if (!disabled) {
      onGroupRemove(path);
    }
  };
  var validationResult = validationMap[id != null ? id : (
    /* istanbul ignore next */
    ""
  )];
  var validationClassName = getValidationClassNames(validationResult);
  var combinatorBasedClassName = useMemo(function() {
    var _getOption$className, _getOption;
    return independentCombinators ? null : (_getOption$className = (_getOption = getOption(combinators, combinator)) == null ? void 0 : _getOption.className) != null ? _getOption$className : "";
  });
  var outerClassName = clsx(getRuleGroupClassname(ruleGroup2), combinatorBasedClassName, standardClassnames.ruleGroup, classNamesProp.ruleGroup, (_clsx4 = {}, _clsx4[standardClassnames.disabled] = disabled, _clsx4[standardClassnames.dndDragging] = isDragging, _clsx4), validationClassName);
  return {
    addGroup,
    addRule,
    classNames,
    cloneGroup,
    combinator,
    disabled,
    dragMonitorId,
    dragRef,
    dropMonitorId,
    dropRef,
    isDragging,
    isOver,
    onCombinatorChange,
    onGroupAdd,
    onIndependentCombinatorChange,
    onNotToggleChange,
    outerClassName,
    parentDisabled,
    previewRef,
    removeGroup,
    ruleGroup: ruleGroup2,
    toggleLockGroup,
    validationClassName,
    validationResult
  };
};
var useSelectElementChangeHandler = function useSelectElementChangeHandler2(_ref19) {
  var multiple = _ref19.multiple, onChange = _ref19.onChange, field = _ref19.field;
  var selectElementChangeHandler3 = useMemo(function() {
    return multiple ? function(e) {
      onChange(Array.from(e).map(function(o) {
        return o;
      }));
    } : function(value2) {
      return onChange(field && typeof value2 === "object" ? value2[field] : value2);
    };
  });
  return selectElementChangeHandler3;
};
var useValueEditor = function useValueEditor2(_ref20) {
  var handleOnChange = _ref20.handleOnChange, inputType = _ref20.inputType, operator = _ref20.operator, value2 = _ref20.value, listsAsArrays = _ref20.listsAsArrays, parseNumbers = _ref20.parseNumbers, values = _ref20.values, skipHook = _ref20.skipHook;
  useEffect(function() {
    if (skipHook)
      return;
    if (inputType === "number" && !["between", "notBetween", "in", "notIn"].includes(operator) && (typeof value2 === "string" && value2.includes(",") || Array.isArray(value2))) {
      var _toArray$;
      handleOnChange((_toArray$ = toArray(value2)[0]) != null ? _toArray$ : "");
    }
  }, [handleOnChange, inputType, operator, skipHook, value2]);
  var valueAsArray = useMemo(function() {
    return toArray(value2);
  });
  var multiValueHandler = useCallback(function(v, i) {
    var val = produce(valueAsArray, function(va) {
      va[i] = parseNumber(v, {
        parseNumbers
      });
      if (i === 0 && (operator === "between" || operator === "notBetween") && !va[1]) {
        va[1] = getFirstOption(values);
      }
    });
    handleOnChange(listsAsArrays ? val : joinWith(val, ","));
  });
  return {
    /**
     * Array of values for when the main value represents a list, e.g. when operator
     * is "between" or "in".
     */
    valueAsArray,
    /**
     * A handler for a series of editors, e.g. when operator is "between".
     * @param {string} val The new value for the editor
     * @param {number} idx The index of the editor
     */
    multiValueHandler
  };
};
var useValueSelector = function useValueSelector2(_ref21) {
  var handleOnChange = _ref21.handleOnChange, _ref21$listsAsArrays = _ref21.listsAsArrays, listsAsArrays = _ref21$listsAsArrays === void 0 ? false : _ref21$listsAsArrays, _ref21$multiple = _ref21.multiple, multiple = _ref21$multiple === void 0 ? false : _ref21$multiple, value2 = _ref21.value;
  var onChange = useCallback(function(v) {
    if (multiple) {
      var valueAsArray = toArray(v);
      handleOnChange(listsAsArrays ? valueAsArray : joinWith(valueAsArray, ","));
    } else {
      handleOnChange(v);
    }
  });
  var val = useMemo(function() {
    return multiple ? toArray(value2) : value2;
  });
  return {
    /**
     * Memoized change handler for value selectors
     */
    onChange,
    /**
     * The value as provided or, if appropriate, as an array
     */
    val
  };
};
var __vue2_script$1 = defineComponent({
  name: "QueryBuilder",
  props: ["defaultQuery", "query", "combinator", "rules", "not", "path", "id", "disabled", "field", "operator", "value", "valueSource", "combinatorPreceding", "independentCombinators", "onLog", "fields", "operators", "combinators", "getDefaultField", "getDefaultOperator", "getDefaultValue", "getOperators", "getValueEditorType", "getValueEditorSeparator", "getValueSources", "getInputType", "getValues", "getRuleClassname", "getRuleGroupClassname", "onAddRule", "onAddGroup", "onRemove", "onQueryChange", "showCombinatorsBetweenRules", "showNotToggle", "showCloneButtons", "showLockButtons", "resetOnFieldChange", "resetOnOperatorChange", "autoSelectField", "autoSelectOperator", "addRuleToNewGroups", "listsAsArrays", "parseNumbers", "disabled", "validateQuery", "validator", "idGenerator", "context", "displayOnlyField", "showBranches"],
  // :QueryBuilderProps
  computed: {
    qb: function qb() {
      return _extends({}, this.$props, useQueryBuilder(this.$props, this));
    },
    ruleGroup: function ruleGroup() {
      var _this$qb$schema, _this$qb$schema$contr;
      return (_this$qb$schema = this.qb.schema) == null ? void 0 : (_this$qb$schema$contr = _this$qb$schema.controls) == null ? void 0 : _this$qb$schema$contr.ruleGroup;
    }
  }
});
var render$1 = function render$12() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    key: _vm.qb.schema.enableDragAndDrop ? "dnd" : "no-dnd"
  }, [_c("div", {
    class: _vm.qb.wrapperClassName,
    attrs: {
      "data-dnd": _vm.qb.schema.enableDragAndDrop ? "enabled" : "disabled",
      "data-inlinecombinators": _vm.qb.schema.independentCombinators || _vm.qb.schema.showCombinatorsBetweenRules ? "enabled" : "disabled"
    }
  }, [_c(_vm.ruleGroup, {
    tag: "component",
    attrs: {
      "translations": _vm.qb.translations,
      "ruleGroup": _vm.query,
      "rules": _vm.query.rules,
      "combinator": "combinator" in _vm.query ? _vm.query.combinator : void 0,
      "not": !!_vm.query.not,
      "schema": _vm.qb.schema,
      "actions": _vm.qb.actions,
      "id": _vm.query.id,
      "path": [],
      "disabled": !!_vm.query.disabled || _vm.qb.queryDisabled,
      "parentDisabled": _vm.qb.queryDisabled,
      "context": _vm.qb.context
    }
  })], 1)]);
};
var staticRenderFns$1 = [];
var __cssModules$1 = {};
var __component__$1 = /* @__PURE__ */ normalizeComponent(__vue2_script$1, render$1, staticRenderFns$1, false, __vue2_injectStyles$1, null, null, null);
function __vue2_injectStyles$1(context) {
  for (var o in __cssModules$1) {
    this[o] = __cssModules$1[o];
  }
}
var QueryBuilder$1 = /* @__PURE__ */ function() {
  return __component__$1.exports;
}();
var getFormatQueryString = function getFormatQueryString2(query, options) {
  var formatQueryResult = formatQuery(query, options);
  if (options.format === "json_without_ids") {
    var result;
    try {
      result = JSON.stringify(JSON.parse(formatQueryResult), null, 2);
    } catch (e) {
      result = formatQueryResult;
      console.error(options.format, e);
    }
    return result;
  } else if (options.format === "parameterized" || options.format === "parameterized_named" || options.format === "jsonlogic") {
    return JSON.stringify(formatQueryResult, null, 2);
  }
  return formatQueryResult;
};
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "tiny-query-builder"
  }, [_c("query-builder", _vm._b({
    key: "queryIC",
    attrs: {
      "independent-combinators": "",
      "query": _vm.query,
      "validator": _vm.validator,
      "on-query-change": _vm.onQueryChange
    }
  }, "query-builder", _vm.config, false))], 1);
};
var staticRenderFns = [];
var __vue2_script = {
  inheritAttrs: false,
  name: $prefix + "QueryBuilder",
  components: {
    QueryBuilder: QueryBuilder$1
  },
  provide: function provide() {
    return {
      queryBuilderRoot: this
    };
  },
  props: {
    config: Object,
    query: Object,
    onQueryChange: Function
  },
  data: function data2() {
    return {
      getFormatQuery: getFormatQueryString,
      // onQueryChange: () => {},
      validator: null
    };
  },
  computed: {
    showClearBtn: function showClearBtn() {
      var _this$query;
      var rules = ((_this$query = this.query) == null ? void 0 : _this$query.rules) || [];
      return this.getRuleTotal(rules) <= 1;
    }
  },
  watch: {
    "config.validateQuery": function configValidateQuery(val, oldVal) {
      if (val !== oldVal) {
        this.validator = val && (this.config.validator || defaultValidator);
      }
    }
  },
  setup: function setup12(props, context) {
    return _setup({
      props,
      context,
      renderless,
      api,
      mono: true
    });
  },
  methods: {
    getRuleTotal: function getRuleTotal(rules) {
      if (rules === void 0) {
        rules = [];
      }
      var len = rules.length;
      if (len === 1 && rules[0].rules) {
        return this.getRuleTotal(rules[0].rules);
      }
      return len;
    }
  }
};
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var QueryBuilder = /* @__PURE__ */ function() {
  return __component__.exports;
}();
var version = "2.8.0";
QueryBuilder.model = {
  prop: "modelValue",
  event: "update:modelValue"
};
QueryBuilder.install = function(Vue) {
  Vue.component(QueryBuilder.name, QueryBuilder);
};
QueryBuilder.version = version;
export {
  QueryBuilder as default
};
