import type { Classnames, DefaultCombinator, DefaultCombinatorExtended, DefaultOperator, DefaultOperatorName, TranslationsFull } from './ts';
export declare const defaultPlaceholderFieldName = "~";
export declare const defaultPlaceholderFieldLabel = "------";
export declare const defaultPlaceholderFieldGroupLabel = "------";
export declare const defaultPlaceholderOperatorName = "~";
export declare const defaultPlaceholderOperatorLabel = "------";
export declare const defaultPlaceholderOperatorGroupLabel = "------";
export declare const defaultJoinChar = ",";
export declare const defaultTranslations: TranslationsFull;
export declare const defaultOperators: DefaultOperator[];
export declare const defaultOperatorNegationMap: Record<DefaultOperatorName, DefaultOperatorName>;
export declare const defaultCombinators: DefaultCombinator[];
export declare const defaultCombinatorsExtended: DefaultCombinatorExtended[];
export declare const standardClassnames: {
    readonly ruleGroup: "ruleGroup";
    readonly queryBuilder: "queryBuilder";
    readonly header: "ruleGroup-header";
    readonly combinators: "ruleGroup-combinators";
    readonly body: "ruleGroup-body";
    readonly addRule: string;
    readonly addGroup: string;
    readonly cloneRule: string;
    readonly cloneGroup: string;
    readonly removeGroup: string;
    readonly notToggle: "ruleGroup-notToggle";
    readonly rule: "query-builder-rule";
    readonly fields: "rule-fields";
    readonly operators: "rule-operators";
    readonly value: "rule-value";
    readonly removeRule: string;
    readonly clearData: string;
    readonly betweenRules: "betweenRules";
    readonly valid: "queryBuilder-valid";
    readonly invalid: "queryBuilder-invalid";
    readonly dndDragging: "dndDragging";
    readonly dndOver: "dndOver";
    readonly dndCopy: "dndCopy";
    readonly dragHandle: "queryBuilder-dragHandle";
    readonly disabled: "queryBuilder-disabled";
    readonly lockRule: "rule-lock";
    readonly lockGroup: "ruleGroup-lock";
    readonly valueSource: "rule-valueSource";
    readonly valueListItem: "rule-value-list-item";
    readonly branches: "queryBuilder-branches";
    readonly displayOnlyField: "display-only-field";
};
export declare const defaultControlClassnames: Classnames;
export declare const groupInvalidReasons: {
    readonly empty: "empty";
    readonly invalidCombinator: "invalid combinator";
    readonly invalidIndependentCombinators: "invalid independent combinators";
};
export declare const TestID: {
    readonly rule: "rule";
    readonly inlineCombinator: "inline-combinator";
    readonly ruleGroup: "rule-group";
    readonly addGroup: "add-group";
    readonly cloneGroup: "clone-group";
    readonly removeGroup: "remove-group";
    readonly cloneRule: "clone-rule";
    readonly addRule: "add-rule";
    readonly combinators: "combinators";
    readonly clearData: "clear-data";
    readonly fields: "fields";
    readonly removeRule: "remove-rule";
    readonly operators: "operators";
    readonly notToggle: "not-toggle";
    readonly valueEditor: "value-editor";
    readonly lockRule: "lock-rule";
    readonly dragHandle: "drag-handle";
    readonly valueSourceSelector: "value-source-selector";
    readonly lockGroup: "lock-group";
};
export declare const LogType: {
    readonly parentPathDisabled: "action aborted: parent path disabled";
    readonly pathDisabled: "action aborted: path is disabled";
    readonly queryUpdate: "query updated";
    readonly onAddRuleFalse: "onAddRule callback returned false";
    readonly onAddGroupFalse: "onAddGroup callback returned false";
    readonly onRemoveFalse: "onRemove callback returned false";
    readonly add: "rule or group added";
    readonly remove: "rule or group removed";
    readonly update: "rule or group updated";
    readonly move: "rule or group moved";
};
