import type { ValueSelectorProps } from '../ts';
export type UseValueSelectorParams = Pick<ValueSelectorProps, 'handleOnChange' | 'listsAsArrays' | 'multiple' | 'value'>;
/**
 * Transforms a value into an array when appropriate and provides
 * a memoized change handler.
 */
export declare const useValueSelector: ({ handleOnChange, listsAsArrays, multiple, value }: UseValueSelectorParams) => {
    /**
     * Memoized change handler for value selectors
     */
    onChange: any;
    /**
     * The value as provided or, if appropriate, as an array
     */
    val: any;
};
