/**
 * Splits a string by a given character (default ','). Escaped characters (characters
 * preceded by a backslash) will not apply to the split, and the backslash will be
 * removed in the array element. Inverse of `joinWith`.
 *
 * @example
 * splitBy('this\\,\\,that,,the other,,,\\,')
 * // or
 * splitBy('this\\,\\,that,,the other,,,\\,', ',')
 * // would return
 * ['this,,that', '', 'the other', '', '', ',']
 */
export declare const splitBy: (str?: string, splitChar?: string) => string[];
/**
 * Joins an array of strings using the given character (default ','). When the given
 * character appears in an array element, a backslash will be added just before it to
 * distinguish it from the join character. Inverse of `splitBy`.
 *
 * @example
 * joinWith(['this,,that', '', 'the other', '', '', ','])
 * // would return
 * 'this\\,\\,that,,the other,,,\\,'
 */
export declare const joinWith: (strArr: (string | undefined | null)[], joinChar?: string) => string;
/**
 * Trims the value if it is a string. Otherwise returns value as-is.
 */
export declare const trimIfString: (val: any) => any;
/**
 * Splits strings by comma and trims each element. Arrays are returned as-is but
 * any string elements are trimmed.
 */
export declare const toArray: (v: any) => any[];
export declare const nullFreeArray: <T>(arr: T[]) => arr is Exclude<T, null>[];
export declare const switchHandler: (action: any, stack: any, vstack: any, lstack: any, symbol: any, lexer: any, preErrorSymbol: any, yyleng: any, yytext: any, yylineno: any, yyloc: any, recovering: any, len: any, yyval: any, ranges: any, r: any, sharedState: any, args: any, newState: any, table: any) => {
    isResult: boolean;
    data: any;
} | undefined;
export declare const lex: (lexer: any, EOF: any, self: any) => any;
export declare const parse: (input: any) => any;
